;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

						.Data?

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

dwEA_Red				DWord	?
dwEA_Green				DWord	?
dwEA_Blue				DWord	?
dwEA_Button				DWord	?
dwEA_Source				DWord	?
dwEA_Destination		DWord	?

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

						.Code

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffects_And	PROC
						LOCAL	_dwRgb:DWord

						mov		eax,DWord Ptr [dwEA_Red]
						shl		eax,16
						mov		ebx,DWord Ptr [dwEA_Green]
						shl		ebx,8
						add		eax,ebx
						add		eax,DWord Ptr [dwEA_Red]
						mov		DWord Ptr [_dwRgb],eax

						mov		ebx,DWord Ptr [lpImageBits]
						mov		edx,DWord Ptr [lpWork]
						mov		edi,DWord Ptr [Image.bmHeight]

ArithmeticsEffects_And_Loop :

						mov		esi,DWord Ptr [Image.bmWidth]

ArithmeticsEffects_And_Loop_1 :

						mov		eax,DWord Ptr [ebx]

						cmp		DWord Ptr [dwEA_Source],TRUE
						jne		ArithmeticsEffects_And_Loop_1_1

						not		eax
						and		eax,0ffffffh

ArithmeticsEffects_And_Loop_1_1 :

						and		eax,DWord Ptr [_dwRgb]
						and		eax,0ffffffh

						cmp		DWord Ptr [dwEA_Destination],TRUE
						jne		ArithmeticsEffects_And_Loop_1_2

						not		eax
						and		eax,0ffffffh

ArithmeticsEffects_And_Loop_1_2 :

						mov		DWord Ptr [edx],eax

ArithmeticsEffects_And_Loop_2 :

						add		ebx,SIZEOF DWord
						add		edx,SIZEOF DWord

						dec		esi
						jnz		ArithmeticsEffects_And_Loop_1

						dec		edi
						jnz		ArithmeticsEffects_And_Loop

						ret
ArithmeticsEffects_And	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffects_Add	PROC
						LOCAL	_dwRgb:DWord

						mov		eax,DWord Ptr [dwEA_Red]
						shl		eax,16
						mov		ebx,DWord Ptr [dwEA_Green]
						shl		ebx,8
						add		eax,ebx
						add		eax,DWord Ptr [dwEA_Red]
						mov		DWord Ptr [_dwRgb],eax

						mov		ebx,DWord Ptr [lpImageBits]
						mov		edx,DWord Ptr [lpWork]
						mov		edi,DWord Ptr [Image.bmHeight]

ArithmeticsEffects_Add_Loop :

						mov		esi,DWord Ptr [Image.bmWidth]

ArithmeticsEffects_Add_Loop_1 :

						mov		eax,DWord Ptr [ebx]

						cmp		DWord Ptr [dwEA_Source],TRUE
						jne		ArithmeticsEffects_Add_Loop_1_1

						not		eax
						and		eax,0ffffffh

ArithmeticsEffects_Add_Loop_1_1 :

						add		eax,DWord Ptr [_dwRgb]
						and		eax,0ffffffh

						cmp		DWord Ptr [dwEA_Destination],TRUE
						jne		ArithmeticsEffects_Add_Loop_1_2

						not		eax
						and		eax,0ffffffh

ArithmeticsEffects_Add_Loop_1_2 :

						mov		DWord Ptr [edx],eax

ArithmeticsEffects_Add_Loop_2 :

						add		ebx,SIZEOF DWord
						add		edx,SIZEOF DWord

						dec		esi
						jnz		ArithmeticsEffects_Add_Loop_1

						dec		edi
						jnz		ArithmeticsEffects_Add_Loop

						ret
ArithmeticsEffects_Add	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffects_Sub	PROC
						LOCAL	_dwRgb:DWord

						mov		eax,DWord Ptr [dwEA_Red]
						shl		eax,16
						mov		ebx,DWord Ptr [dwEA_Green]
						shl		eax,8
						add		eax,ebx
						add		eax,DWord Ptr [dwEA_Red]
						mov		DWord Ptr [_dwRgb],eax

						mov		ebx,DWord Ptr [lpImageBits]
						mov		edx,DWord Ptr [lpWork]
						mov		edi,DWord Ptr [Image.bmHeight]

ArithmeticsEffects_Sub_Loop :

						mov		esi,DWord Ptr [Image.bmWidth]

ArithmeticsEffects_Sub_Loop_1 :

						mov		eax,DWord Ptr [ebx]

						cmp		DWord Ptr [dwEA_Source],TRUE
						jne		ArithmeticsEffects_Sub_Loop_1_1

						not		eax
						and		eax,0ffffffh

ArithmeticsEffects_Sub_Loop_1_1 :

						sub		eax,DWord Ptr [_dwRgb]
						and		eax,0ffffffh

						cmp		DWord Ptr [dwEA_Destination],TRUE
						jne		ArithmeticsEffects_Sub_Loop_1_2

						not		eax
						and		eax,0ffffffh

ArithmeticsEffects_Sub_Loop_1_2 :

						mov		DWord Ptr [edx],eax

ArithmeticsEffects_Sub_Loop_2 :

						add		ebx,SIZEOF DWord
						add		edx,SIZEOF DWord

						dec		esi
						jnz		ArithmeticsEffects_Sub_Loop_1

						dec		edi
						jnz		ArithmeticsEffects_Sub_Loop

						ret
ArithmeticsEffects_Sub	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffects_Xor	PROC
						LOCAL	_dwRgb:DWord

						mov		eax,DWord Ptr [dwEA_Red]
						shl		eax,16
						mov		ebx,DWord Ptr [dwEA_Green]
						shl		eax,8
						add		eax,ebx
						add		eax,DWord Ptr [dwEA_Red]
						mov		DWord Ptr [_dwRgb],eax

						mov		ebx,DWord Ptr [lpImageBits]
						mov		edx,DWord Ptr [lpWork]
						mov		edi,DWord Ptr [Image.bmHeight]

ArithmeticsEffects_Xor_Loop :

						mov		esi,DWord Ptr [Image.bmWidth]

ArithmeticsEffects_Xor_Loop_1 :

						mov		eax,DWord Ptr [ebx]

						cmp		DWord Ptr [dwEA_Source],TRUE
						jne		ArithmeticsEffects_Xor_Loop_1_1

						not		eax
						and		eax,0ffffffh

ArithmeticsEffects_Xor_Loop_1_1 :

						xor		eax,DWord Ptr [_dwRgb]
						and		eax,0ffffffh

						cmp		DWord Ptr [dwEA_Destination],TRUE
						jne		ArithmeticsEffects_Xor_Loop_1_2

						not		eax
						and		eax,0ffffffh

ArithmeticsEffects_Xor_Loop_1_2 :

						mov		DWord Ptr [edx],eax

ArithmeticsEffects_Xor_Loop_2 :

						add		ebx,SIZEOF DWord
						add		edx,SIZEOF DWord

						dec		esi
						jnz		ArithmeticsEffects_Xor_Loop_1

						dec		edi
						jnz		ArithmeticsEffects_Xor_Loop

						ret
ArithmeticsEffects_Xor	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffects_Or	PROC
						LOCAL	_dwRgb:DWord

						mov		eax,DWord Ptr [dwEA_Red]
						shl		eax,16
						mov		ebx,DWord Ptr [dwEA_Green]
						shl		eax,8
						add		eax,ebx
						add		eax,DWord Ptr [dwEA_Red]
						mov		DWord Ptr [_dwRgb],eax

						mov		ebx,DWord Ptr [lpImageBits]
						mov		edx,DWord Ptr [lpWork]
						mov		edi,DWord Ptr [Image.bmHeight]

ArithmeticsEffects_Or_Loop :

						mov		esi,DWord Ptr [Image.bmWidth]

ArithmeticsEffects_Or_Loop_1 :

						mov		eax,DWord Ptr [ebx]

						cmp		DWord Ptr [dwEA_Source],TRUE
						jne		ArithmeticsEffects_Or_Loop_1_1

						not		eax
						and		eax,0ffffffh

ArithmeticsEffects_Or_Loop_1_1 :

						or		eax,DWord Ptr [_dwRgb]
						and		eax,0ffffffh

						cmp		DWord Ptr [dwEA_Destination],TRUE
						jne		ArithmeticsEffects_Or_Loop_1_2

						not		eax
						and		eax,0ffffffh

ArithmeticsEffects_Or_Loop_1_2 :

						mov		DWord Ptr [edx],eax

ArithmeticsEffects_Or_Loop_2 :

						add		ebx,SIZEOF DWord
						add		edx,SIZEOF DWord

						dec		esi
						jnz		ArithmeticsEffects_Or_Loop_1

						dec		edi
						jnz		ArithmeticsEffects_Or_Loop

						ret
ArithmeticsEffects_Or	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffects_SetTitle	PROC	hWnd:HWND
						LOCAL	szTmp[256]:Byte

						lea		esi,szTmp

						push	DWord Ptr [dwEA_Blue]
						push	DWord Ptr [dwEA_Green]
						push	DWord Ptr [dwEA_Red]
						push	OFFSET szFmtEA_001
						push	esi
						call	wsprintf

						add		esp,20

						push	esi
						push	DWord Ptr [hWnd]
						call	SetWindowText

						ret
ArithmeticsEffects_SetTitle	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffects_Initialize	PROC	hWnd:HWND
						LOCAL	hSlider_01:HWND
						LOCAL	hSlider_02:HWND
						LOCAL	hSlider_03:HWND

						INVOKE	GetDlgItem,hWnd,IDC_SLIDER_01
						mov		DWord Ptr [hSlider_01],eax

						INVOKE	GetDlgItem,hWnd,IDC_SLIDER_02
						mov		DWord Ptr [hSlider_02],eax

						INVOKE	GetDlgItem,hWnd,IDC_SLIDER_03
						mov		DWord Ptr [hSlider_03],eax

						push	DWord Ptr [hWnd]
						call	ArithmeticsEffects_SetTitle

						INVOKE	SendMessage,hSlider_01,TBM_SETRANGE,TRUE,00ff0000h
						INVOKE	SendMessage,hSlider_02,TBM_SETRANGE,TRUE,00ff0000h
						INVOKE	SendMessage,hSlider_03,TBM_SETRANGE,TRUE,00ff0000h

						INVOKE	SendMessage,hSlider_01,TBM_SETPOS,TRUE,dwEA_Red
						INVOKE	SendMessage,hSlider_02,TBM_SETPOS,TRUE,dwEA_Green
						INVOKE	SendMessage,hSlider_03,TBM_SETPOS,TRUE,dwEA_Blue

						INVOKE	SetFocus,hSlider_01

						ret
ArithmeticsEffects_Initialize	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffects_Init	PROC	hWnd:HWND

						mov		DWord Ptr [dwEA_Red],128
						mov		DWord Ptr [dwEA_Green],128
						mov		DWord Ptr [dwEA_Blue],128

						push	DWord Ptr [hWnd]
						call	ArithmeticsEffects_Initialize

						INVOKE	CheckRadioButton,hWnd,IDC_RADIO_01,IDC_RADIO_04,IDC_RADIO_01

						ret
ArithmeticsEffects_Init	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffects_Command	PROC	hWnd:HWND,wParam:WPARAM,lParam:LPARAM

						mov		eax,DWord Ptr [wParam]
						and		eax,0000ffffh

						cmp		eax,IDOK
						jne		ArithmeticsEffects_Command_1

						INVOKE	IsDlgButtonChecked,hWnd,IDC_CHECK_01

						cmp		eax,BST_CHECKED
						je		ArithmeticsEffects_Command_InvertSource

ArithmeticsEffects_Command_InvertDestination :

						INVOKE	IsDlgButtonChecked,hWnd,IDC_CHECK_02

						cmp		eax,BST_CHECKED
						jne		ArithmeticsEffects_Command_0

						mov		DWord Ptr [dwEA_Destination],TRUE
						jmp		ArithmeticsEffects_Command_0

ArithmeticsEffects_Command_InvertSource :

						mov		DWord Ptr [dwEA_Source],TRUE
						jmp		ArithmeticsEffects_Command_InvertDestination

ArithmeticsEffects_Command_0 :

						INVOKE	IsDlgButtonChecked,hWnd,IDC_RADIO_01

						cmp		eax,BST_CHECKED
						je		ArithmeticsEffects_Command_ButtonAdd

						INVOKE	IsDlgButtonChecked,hWnd,IDC_RADIO_02

						cmp		eax,BST_CHECKED
						je		ArithmeticsEffects_Command_ButtonSub

						INVOKE	IsDlgButtonChecked,hWnd,IDC_RADIO_03

						cmp		eax,BST_CHECKED
						je		ArithmeticsEffects_Command_ButtonXor

						INVOKE	IsDlgButtonChecked,hWnd,IDC_RADIO_04

						cmp		eax,BST_CHECKED
						je		ArithmeticsEffects_Command_ButtonOr

ArithmeticsEffects_Command_ButtonAnd :

						mov		DWord Ptr [dwEA_Button],IDC_RADIO_05
						jmp		ArithmeticsEffects_Command_1_1

ArithmeticsEffects_Command_ButtonOr :

						mov		DWord Ptr [dwEA_Button],IDC_RADIO_04
						jmp		ArithmeticsEffects_Command_1_1

ArithmeticsEffects_Command_ButtonAdd :

						mov		DWord Ptr [dwEA_Button],IDC_RADIO_01
						jmp		ArithmeticsEffects_Command_1_1

ArithmeticsEffects_Command_ButtonSub :

						mov		DWord Ptr [dwEA_Button],IDC_RADIO_02
						jmp		ArithmeticsEffects_Command_1_1

ArithmeticsEffects_Command_ButtonXor :

						mov		DWord Ptr [dwEA_Button],IDC_RADIO_03
						jmp		ArithmeticsEffects_Command_1_1

ArithmeticsEffects_Command_1 :

						cmp		eax,IDCANCEL
						jne		ArithmeticsEffects_Command_2

ArithmeticsEffects_Command_1_1 :

						push	DWord Ptr [wParam]
						push	DWord Ptr [hWnd]
						push	OFFSET ArithmeticsEffects_Command_Exit
						jmp		EndDialog

ArithmeticsEffects_Command_2 :

ArithmeticsEffects_Command_Exit :

						ret
ArithmeticsEffects_Command	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffects_HScroll	PROC	hWnd:HWND,wParam:WPARAM,lParam:LPARAM
						LOCAL	dwPosition:DWord

						mov		eax,DWord Ptr [wParam]
						and		eax,0000ffffh

						cmp		eax,SB_PAGERIGHT
						je		ArithmeticsEffects_HScroll_Right

						cmp		eax,SB_PAGELEFT
						je		ArithmeticsEffects_HScroll_Right

						cmp		eax,SB_LINELEFT
						je		ArithmeticsEffects_HScroll_Right

						cmp		eax,SB_LINERIGHT
						je		ArithmeticsEffects_HScroll_Right

						cmp		eax,SB_THUMBTRACK
						jne		ArithmeticsEffects_HScroll_Exit

						movzx	eax,Word Ptr [wParam + 2]

ArithmeticsEffects_HScroll_0 :
						mov		DWord Ptr [dwPosition],eax

						push	DWord Ptr [lParam]
						call	GetMenu

						cmp		eax,IDC_SLIDER_01
						je		ArithmeticsEffects_HScroll_1

						cmp		eax,IDC_SLIDER_02
						je		ArithmeticsEffects_HScroll_2

						mov		eax,DWord Ptr [dwPosition]
						mov		DWord Ptr [dwEA_Blue],eax
						jmp		ArithmeticsEffects_HScroll_3

ArithmeticsEffects_HScroll_1 :

						mov		eax,DWord Ptr [dwPosition]
						mov		DWord Ptr [dwEA_Red],eax
						jmp		ArithmeticsEffects_HScroll_3

ArithmeticsEffects_HScroll_2 :

						mov		eax,DWord Ptr [dwPosition]
						mov		DWord Ptr [dwEA_Green],eax

ArithmeticsEffects_HScroll_3 :

						push	DWord Ptr [hWnd]
						push	OFFSET ArithmeticsEffects_HScroll_Exit
						jmp		ArithmeticsEffects_SetTitle

ArithmeticsEffects_HScroll_Right :

						push	0
						push	0
						push	TBM_GETPOS
						push	DWord Ptr [lParam]
						push	OFFSET ArithmeticsEffects_HScroll_0
						jmp		SendMessage

ArithmeticsEffects_HScroll_Exit :

						ret
ArithmeticsEffects_HScroll	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffectsDlgProc	PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

						mov		eax,DWord Ptr [uMsg]

						cmp		eax,WM_INITDIALOG
						jne		ArithmeticsEffectsDlgProc_1

							push	DWord Ptr [hWnd]
							call	ArithmeticsEffects_Init

							xor		eax,eax
							inc		eax
							jmp		ArithmeticsEffectsDlgProc_Exit

ArithmeticsEffectsDlgProc_1 :

						cmp		eax,WM_COMMAND
						jne		ArithmeticsEffectsDlgProc_2

							push	DWord Ptr [lParam]
							push	DWord Ptr [wParam]
							push	DWord Ptr [hWnd]
							push	OFFSET ArithmeticsEffectsDlgProc_End
							jmp		ArithmeticsEffects_Command

ArithmeticsEffectsDlgProc_2 :

						cmp		eax,WM_CLOSE
						jne		ArithmeticsEffectsDlgProc_3

							push	IDCANCEL
							push	DWord Ptr [hWnd]
							push	OFFSET ArithmeticsEffectsDlgProc_End
							jmp		EndDialog

ArithmeticsEffectsDlgProc_3 :

						cmp		eax,WM_HSCROLL
						jne		ArithmeticsEffectsDlgProc_End

							push	DWord Ptr [lParam]
							push	DWord Ptr [wParam]
							push	DWord Ptr [hWnd]
							push	OFFSET ArithmeticsEffectsDlgProc_End
							jmp		ArithmeticsEffects_HScroll

ArithmeticsEffectsDlgProc_End :

						xor		eax,eax

ArithmeticsEffectsDlgProc_Exit :

						ret
ArithmeticsEffectsDlgProc		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffectsWmCreate		PROC	hWnd:HWND
						LOCAL	hTmp:HBITMAP
						LOCAL	hDC:HDC

						push	DWord Ptr [hWnd]
						call	Window_SetDim

						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		GetDC

						mov		DWord Ptr [hDC],eax

						push	DIB_RGB_COLORS
						push	OFFSET ImageInfo
						push	DWord Ptr [lpWork]
						push	CBM_INIT
						push	OFFSET ImageInfo
						push	DWord Ptr hDC
						push	OFFSET $ + 10
						jmp		CreateDIBitmap

						mov		DWord Ptr [hTmp],eax

						push	DWord Ptr [hDC]
						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		ReleaseDC

						push	DWord Ptr [hTmp]
						push	0
						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		SetWindowLong

						xor		eax,eax
						ret
ArithmeticsEffectsWmCreate	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffectsWmPaint	PROC	hWnd:HWND
						LOCAL	hDC:HDC
						LOCAL	hDCMem:HDC
						LOCAL	hBmpOld
						LOCAL	hBmpImage:HBITMAP
						LOCAL	dwNewWidth:DWord
						LOCAL	dwNewHeight:DWord
						LOCAL	rc:RECT
						LOCAL	rc2:RECT
						LOCAL	PsP:PAINTSTRUCT

						lea		eax,PsP

						push	eax
						push	DWord Ptr [hWnd]
						call	BeginPaint 

						mov		DWord Ptr [hDC],eax

						invoke	CreateCompatibleDC,hDC
						mov		DWord Ptr [hDCMem],eax

						push	0
						push	DWord Ptr [hWnd]
						call	GetWindowLong

						mov		DWord Ptr [hBmpImage],eax

						invoke	SelectObject,hDCMem,hBmpImage
						mov		DWord Ptr [hBmpOld],eax

						invoke	GetClientRect,hWnd,ADDR rc

						push	DWord Ptr [hWnd]
						call	Bitmap_Proportions

						mov		DWord Ptr [dwNewWidth],eax
						mov		DWord Ptr [dwNewHeight],edx

						invoke	SetRect,ADDR rc2,0,0,rc.right,rc.bottom

						push	LTGRAY_BRUSH
						call	GetStockObject

						push	eax
						lea		eax,rc2
						push	eax
						push	DWord Ptr [hDC]
						call	FillRect

						invoke	SetStretchBltMode,hDC,COLORONCOLOR

						push	SRCCOPY
						push	DWord Ptr [Image.bmHeight]
						push	DWord Ptr [Image.bmWidth]
						push	0
						push	0
						push	DWord Ptr [hDCMem]
						push	DWord Ptr [dwNewHeight]
						push	DWord Ptr [dwNewWidth]
						push	0
						push	0
						push	DWord Ptr [hDC]
						call	StretchBlt

						invoke	SelectObject,hDCMem,hBmpOld

						lea		eax,PsP

						push	eax
						push	DWord Ptr [hWnd]
						call	EndPaint

						ret
ArithmeticsEffectsWmPaint	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffectsWmClose	PROC	hWnd:HWND

						push	0
						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		GetWindowLong

						push	eax
						push	OFFSET $ + 10
						jmp		DeleteObject

						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		DestroyWindow

						ret
ArithmeticsEffectsWmClose	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffectsProc	PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

						mov		eax,DWord Ptr [uMsg]

						cmp		eax,WM_CREATE
						jne		@F

							push	DWord Ptr [hWnd]
							push	OFFSET ArithmeticsEffectsProc_Exit
							jmp		ArithmeticsEffectsWmCreate

@@ :

						cmp 	eax,WM_PAINT
						jne		@F

							push	DWord Ptr [hWnd]
							push	OFFSET ArithmeticsEffectsProc_Exit
							jmp		ArithmeticsEffectsWmPaint

@@ :

						cmp		eax,WM_ERASEBKGND
						jne		@F

							xor		eax,eax
							inc		eax
							jmp		ArithmeticsEffectsProc_End

@@ :

						cmp		eax,WM_CLOSE
						jne		@F


							push	DWord Ptr [hWnd]
							push	OFFSET ArithmeticsEffectsProc_End
							jmp		ArithmeticsEffectsWmClose

@@ :

ArithmeticsEffectsProc_Default :

						push	DWord Ptr [lParam]
						push	DWord Ptr [wParam]
						push	DWord Ptr [uMsg]
						push	DWord Ptr [hWnd]
						push	OFFSET ArithmeticsEffectsProc_End
						jmp		DefWindowProc

ArithmeticsEffectsProc_Exit :

						xor    eax,eax

ArithmeticsEffectsProc_End :

						ret
ArithmeticsEffectsProc	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

ArithmeticsEffects		PROC	hWnd:HWND
						LOCAL	hTmp:HWND
						LOCAL	dwWidth:DWord
						LOCAL	dwHeight:DWord

						mov		DWord Ptr [dwEA_Source],0
						mov		DWord Ptr [dwEA_Destination],0

						push	NULL
						push	OFFSET ArithmeticsEffectsDlgProc
						push	DWord Ptr [hWnd]
						push	DLG_COLOURS
						push	DWord Ptr [hInstance]
						call	DialogBoxParam

						cmp		eax,IDOK
						jne		ArithmeticsEffects_Exit

						cmp		DWord Ptr [dwEA_Button],IDC_RADIO_01	; ADD
						je		ArithmeticsEffectsAdd

						cmp		DWord Ptr [dwEA_Button],IDC_RADIO_02	; SUB
						je		ArithmeticsEffectsSub

						cmp		DWord Ptr [dwEA_Button],IDC_RADIO_03	; XOR
						je		ArithmeticsEffectsXor

						cmp		DWord Ptr [dwEA_Button],IDC_RADIO_04	; XOR
						je		ArithmeticsEffectsOr

						jmp		ArithmeticsEffectsAnd

ArithmeticsEffectsOr :

						push	OFFSET ArithmeticsEffects_Next
						jmp		ArithmeticsEffects_Or

ArithmeticsEffectsAdd :

						push	OFFSET ArithmeticsEffects_Next
						jmp		ArithmeticsEffects_Add

ArithmeticsEffectsSub :

						push	OFFSET ArithmeticsEffects_Next
						jmp		ArithmeticsEffects_Sub

ArithmeticsEffectsAnd :

						push	OFFSET ArithmeticsEffects_Next
						jmp		ArithmeticsEffects_And

ArithmeticsEffectsXor :

						call	ArithmeticsEffects_Xor

ArithmeticsEffects_Next :

						mov		eax,DWord Ptr rcWorkArea.right
						sub		eax,DWord Ptr rcWorkArea.left
						mov		DWord Ptr dwWidth,eax

						mov		eax,DWord Ptr rcWorkArea.bottom
						sub		eax,DWord Ptr rcWorkArea.top
						mov		DWord Ptr dwHeight,eax

						push	NULL
						push	DWord Ptr [hInstance]
						push	NULL
						push	DWord Ptr [hWnd]
						push	DWord Ptr dwHeight
						push	DWord Ptr dwWidth
						push	rcWorkArea.top
						push	rcWorkArea.left
						push	WS_POPUP or WS_CAPTION or WS_VISIBLE or WS_SYSMENU
						push	OFFSET szArithmeticsEffectsTitle
						push	OFFSET szArithmeticsEffectsClass
						push	0
						call	CreateWindowEx

						mov		DWord Ptr [hTmp],eax

						push	SW_SHOW
						push	DWord Ptr [hTmp]
						call	ShowWindow

						push	DWord Ptr [hTmp]
						call	UpdateWindow

ArithmeticsEffects_Exit :

						ret
ArithmeticsEffects		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################
