; gdiplus_structures_ver1.inc         additions: 03/05
; original version by xzazet
;
; 1) GUID conversion added
;
; 2)  EncoderParameter  STRUC     is:
;                        pGUID  GUID <?>
;                  {not  pGUID  DWORD ?}

;dougiem


;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

; E-Z GUID Converting from C++ to MASM, by NaN, 2002

;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

MGUID macro a_c_guid
      LOCAL guidsize, guid1, guid2, guid3, guid4, guid5, guid6, guid7, guid8, guid9, guid10, guid11
      quidsize = @SizeStr(a_c_guid)
      if quidsize eq 36
         guid1 SUBSTR <a_c_guid>, 1, 8
         guid1 CATSTR <0>,guid1,<H>
         guid2 SUBSTR <a_c_guid>, 10, 4
         guid2 CATSTR <0>,guid2,<H>
         guid3 SUBSTR <a_c_guid>, 15, 4
         guid3 CATSTR <0>,guid3,<H>
         guid4 SUBSTR <a_c_guid>, 20, 2
         guid4 CATSTR <0>,guid4,<H>
         guid5 SUBSTR <a_c_guid>, 22, 2
         guid5 CATSTR <0>,guid5,<H>
         guid6 SUBSTR <a_c_guid>, 25, 2
         guid6 CATSTR <0>,guid6,<H>
         guid7 SUBSTR <a_c_guid>, 27, 2
         guid7 CATSTR <0>,guid7,<H>
         guid8 SUBSTR <a_c_guid>, 29, 2
         guid8 CATSTR <0>,guid8,<H>
         guid9 SUBSTR <a_c_guid>, 31, 2
         guid9 CATSTR <0>,guid9,<H>
         guid10 SUBSTR <a_c_guid>, 33, 2
         guid10 CATSTR <0>,guid10,<H>
         guid11 SUBSTR <a_c_guid>, 35, 2
         guid11 CATSTR <0>,guid11,<H>
      else
         echo
         echo FORMAT:  LABEL MGUID (0000000-0000-0000-0000-000000000000)
         echo Must be 36 bytes long, including dashes!
         echo
         .err <MGUID ERROR>
      endif
      exitm <TEXTEQU !<{guid1, guid2, guid3, {guid4, guid5, guid6, guid7, guid8, guid9, guid10, guid11}}!> >     
endm  


;---------------------------------------------------------------------------
; Decoder parameter sets
;---------------------------------------------------------------------------
     GUID_DecoderTransColor       MGUID (b7a98c8f-dce7-457d-bfa5-cea71bd14dd6)
     GUID_DecoderTransRange       MGUID (abeed189-d988-4d03-b425-571055c76ad1)
     GUID_DecoderOutputChannel    MGUID (2ff8f51e-724d-45fe-86ce-1777a056da60)
     GUID_DecoderIconRes          MGUID (5c656eec-e94f-45ba-a6f6-1062e85f4a7f)

;---------------------------------------------------------------------------
; Encoder parameter sets
;---------------------------------------------------------------------------
     GUID_EncoderCompression      MGUID (E09D739D-ccd4-44ee-8eba-3fbf8be4fc58)
     GUID_EncoderColorDepth       MGUID (66087055-ad66-4c7c-9a18-38a2310b8337)
     GUID_EncoderScanMethod       MGUID (3A4E2661-3109-4e56-8536-42c156e7dcfa)
     GUID_EncoderVersion          MGUID (24D18C76-814a-41a4-bf53-1c219cccf797)
     GUID_EncoderRenderMethod     MGUID (6D42C53A-229a-4825-8bb7-5c99e2b9a8b8)
     GUID_EncoderQuality          MGUID (1D5BE4B5-fa4a-452d-9cdd-5db35105e7eb)
     GUID_EncoderTransformation   MGUID (8D0EB2D1-a58e-4ea8-aa14-108074b7b6f9)
     GUID_EncoderLuminanceTable   MGUID (EDB33BCE-0266-4a77-b904-27216099e717)
     GUID_EncoderChrominanceTable MGUID (F2E455DC-09b3-4316-8260-676ada32481c)
     GUID_EncoderSaveFlag         MGUID (292266FC-ac40-47bf-8cfc-a85b89a655de)
     GUID_CodecIImageBytes        MGUID (025D1823-6c7d-447b-bbdb-a3cbc3dfa2fc)

;---------------------------------------------------------------------------
; Image format sets
;---------------------------------------------------------------------------
     GUID_ImageFormatUndefined    MGUID (B96B3CA9-0728-11D3-9D7B-0000F81EF32E)
     GUID_ImageFormatMemoryBMP    MGUID (B96B3CAA-0728-11D3-9D7B-0000F81EF32E)
     GUID_ImageFormatBMP          MGUID (B96B3CAB-0728-11D3-9D7B-0000F81EF32E)
     GUID_ImageFormatEMF          MGUID (B96B3CAC-0728-11D3-9D7B-0000F81EF32E)
     GUID_ImageFormatWMF          MGUID (B96B3CAD-0728-11D3-9D7B-0000F81EF32E)
     GUID_ImageFormatJPEG         MGUID (B96B3CAE-0728-11D3-9D7B-0000F81EF32E)
     GUID_ImageFormatPNG          MGUID (B96B3CAF-0728-11D3-9D7B-0000F81EF32E)
     GUID_ImageFormatGIF          MGUID (B96B3CB0-0728-11D3-9D7B-0000F81EF32E)
     GUID_ImageFormatTIFF         MGUID (B96B3CB1-0728-11D3-9D7B-0000F81EF32E)
     GUID_ImageFormatEXIF         MGUID (B96B3CB2-0728-11D3-9D7B-0000F81EF32E)
     GUID_ImageFormatIcon         MGUID (B96B3CB3-0728-11D3-9D7B-0000F81EF32E)



.data

     ImageFormatUndefined         GUID GUID_ImageFormatUndefined
     ImageFormatMemoryBMP         GUID GUID_ImageFormatMemoryBMP
     ImageFormatBMP               GUID GUID_ImageFormatBMP
     ImageFormatEMF               GUID GUID_ImageFormatEMF
     ImageFormatWMF               GUID GUID_ImageFormatWMF
     ImageFormatJPEG              GUID GUID_ImageFormatJPEG
     ImageFormatPNG               GUID GUID_ImageFormatPNG
     ImageFormatGIF               GUID GUID_ImageFormatGIF
     ImageFormatTIFF              GUID GUID_ImageFormatTIFF
     ImageFormatEXIF              GUID GUID_ImageFormatEXIF
     ImageFormatIcon              GUID GUID_ImageFormatIcon

     DecoderTransColor            GUID GUID_DecoderTransColor     
     DecoderTransRange            GUID GUID_DecoderTransRange    
     DecoderOutputChannel         GUID GUID_DecoderOutputChannel 
     DecoderIconRes               GUID GUID_DecoderIconRes  

     gEncoderCompression          GUID GUID_EncoderCompression       
     gEncoderColorDepth           GUID GUID_EncoderColorDepth    
     gEncoderScanMethod           GUID GUID_EncoderScanMethod    
     gEncoderVersion              GUID GUID_EncoderVersion           
     gEncoderRenderMethod         GUID GUID_EncoderRenderMethod 
     gEncoderQuality              GUID GUID_EncoderQuality    
     gEncoderTransformation       GUID GUID_EncoderTransformation 
     gEncoderLuminanceTable       GUID GUID_EncoderLuminanceTable 
     gEncoderChrominanceTable     GUID GUID_EncoderChrominanceTable  
     gEncoderSaveFlag             GUID GUID_EncoderSaveFlag    
     gCodecIImageBytes            GUID GUID_CodecIImageBytes  
;dougiem



.data?
GdiplusStartupInput STRUCT
    GdiplusVersion           DWORD ?
    DebugEventCallback       DWORD ?
    SuppressBackgroundThread DWORD ?
    SuppressExternalCodecs   DWORD ?
GdiplusStartupInput ENDS

PointF STRUCT
    x         REAL4 ?
    y         REAL4 ?
PointF ENDS

RectF STRUCT
    Left      REAL4 ?
    Top       REAL4 ?
    Right     REAL4 ?
    Bottom    REAL4 ?
RectF ENDS

SizeF STRUCT
    sx        REAL4 ?
    sy        REAL4 ?
SizeF ENDS

; xzazet
;-----------------------------------------------
; GDI+ Constants
;-----------------------------------------------
LF_FACESIZE = 32
; Shift count and bit mask for A, R, G, B components
AlphaShift    equ  24
RedShift      equ  16
GreenShift    equ  8
BlueShift     equ  0
AlphaMask     equ  0FF000000h
RedMask       equ  000FF0000h
GreenMask     equ  00000FF00h
BlueMask      equ  0000000FFh

; Image property types
PropertyTagTypeByte               equ  1
PropertyTagTypeASCII              equ  2
PropertyTagTypeShort              equ  3
PropertyTagTypeLong               equ  4
PropertyTagTypeRational           equ  5
PropertyTagTypeUndefined          equ  7
PropertyTagTypeSLONG              equ  9
PropertyTagTypeSRational          equ  10

; Image property ID tags
PropertyTagExifIFD                equ  8769h
PropertyTagGpsIFD                 equ  8825h

PropertyTagNewSubfileType         equ  0FEh
PropertyTagSubfileType            equ  0FFh
PropertyTagImageWidth             equ  100h
PropertyTagImageHeight            equ  101h
PropertyTagBitsPerSample          equ  102h
PropertyTagCompression            equ  103h
PropertyTagPhotometricInterp      equ  106h
PropertyTagThreshHolding          equ  107h
PropertyTagCellWidth              equ  108h
PropertyTagCellHeight             equ  109h
PropertyTagFillOrder              equ  10Ah
PropertyTagDocumentName           equ  10Dh
PropertyTagImageDescription       equ  10Eh
PropertyTagEquipMake              equ  10Fh
PropertyTagEquipModel             equ  110h
PropertyTagStripOffsets           equ  111h
PropertyTagOrientation            equ  112h
PropertyTagSamplesPerPixel        equ  115h
PropertyTagRowsPerStrip           equ  116h
PropertyTagStripBytesCount        equ  117h
PropertyTagMinSampleValue         equ  118h
PropertyTagMaxSampleValue         equ  119h
PropertyTagXResolution            equ  11Ah      ; Image resolution in width direction
PropertyTagYResolution            equ  11Bh      ; Image resolution in height direction
PropertyTagPlanarConfig           equ  11Ch      ; Image data arrangement
PropertyTagPageName               equ  11Dh
PropertyTagXPosition              equ  11Eh
PropertyTagYPosition              equ  11Fh
PropertyTagFreeOffset             equ  120h
PropertyTagFreeByteCounts         equ  121h
PropertyTagGrayResponseUnit       equ  122h
PropertyTagGrayResponseCurve      equ  123h
PropertyTagT4Option               equ  124h
PropertyTagT6Option               equ  125h
PropertyTagResolutionUnit         equ  128h      ; Unit of X and Y resolution
PropertyTagPageNumber             equ  129h
PropertyTagTransferFuncition      equ  12Dh
PropertyTagSoftwareUsed           equ  131h
PropertyTagDateTime               equ  132h
PropertyTagArtist                 equ  13Bh
PropertyTagHostComputer           equ  13Ch
PropertyTagPredictor              equ  13Dh
PropertyTagWhitePoint             equ  13Eh
PropertyTagPrimaryChromaticities  equ  13Fh
PropertyTagColorMap               equ  140h
PropertyTagHalftoneHints          equ  141h
PropertyTagTileWidth              equ  142h
PropertyTagTileLength             equ  143h
PropertyTagTileOffset             equ  144h
PropertyTagTileByteCounts         equ  145h
PropertyTagInkSet                 equ  14Ch
PropertyTagInkNames               equ  14Dh
PropertyTagNumberOfInks           equ  14Eh
PropertyTagDotRange               equ  150h
PropertyTagTargetPrinter          equ  151h
PropertyTagExtraSamples           equ  152h
PropertyTagSampleFormat           equ  153h
PropertyTagSMinSampleValue        equ  154h
PropertyTagSMaxSampleValue        equ  155h
PropertyTagTransferRange          equ  156h

PropertyTagJPEGProc               equ  200h
PropertyTagJPEGInterFormat        equ  201h
PropertyTagJPEGInterLength        equ  202h
PropertyTagJPEGRestartInterval    equ  203h
PropertyTagJPEGLosslessPredictors equ  205h
PropertyTagJPEGPointTransforms    equ  206h
PropertyTagJPEGQTables            equ  207h
PropertyTagJPEGDCTables           equ  208h
PropertyTagJPEGACTables           equ  209h
PropertyTagYCbCrCoefficients      equ  211h
PropertyTagYCbCrSubsampling       equ  212h
PropertyTagYCbCrPositioning       equ  213h
PropertyTagREFBlackWhite          equ  214h
PropertyTagICCProfile             equ  8773h     ; This TAG is defined by ICC for embedded ICC in TIFF
PropertyTagGamma                  equ  301h
PropertyTagICCProfileDescriptor   equ  302h
PropertyTagSRGBRenderingIntent    equ  303h
PropertyTagImageTitle             equ  320h
PropertyTagCopyright              equ  8298h

; Extra TAGs (Like Adobe Image Information tags etc.)
PropertyTagResolutionXUnit             equ  5001h
PropertyTagResolutionYUnit             equ  5002h
PropertyTagResolutionXLengthUnit       equ  5003h
PropertyTagResolutionYLengthUnit       equ  5004h
PropertyTagPrintFlags                  equ  5005h
PropertyTagPrintFlagsVersion           equ  5006h
PropertyTagPrintFlagsCrop              equ  5007h
PropertyTagPrintFlagsBleedWidth        equ  5008h
PropertyTagPrintFlagsBleedWidthScale   equ  5009h
PropertyTagHalftoneLPI                 equ  500Ah
PropertyTagHalftoneLPIUnit             equ  500Bh
PropertyTagHalftoneDegree              equ  500Ch
PropertyTagHalftoneShape               equ  500Dh
PropertyTagHalftoneMisc                equ  500Eh
PropertyTagHalftoneScreen              equ  500Fh
PropertyTagJPEGQuality                 equ  5010h
PropertyTagGridSize                    equ  5011h
PropertyTagThumbnailFormat             equ  5012h     ; 1 = JPEG, 0 = RAW RGB
PropertyTagThumbnailWidth              equ  5013h
PropertyTagThumbnailHeight             equ  5014h
PropertyTagThumbnailColorDepth         equ  5015h
PropertyTagThumbnailPlanes             equ  5016h
PropertyTagThumbnailRawBytes           equ  5017h
PropertyTagThumbnailSize               equ  5018h
PropertyTagThumbnailCompressedSize     equ  5019h
PropertyTagColorTransferFunction       equ  501Ah
PropertyTagThumbnailData               equ  501Bh     ; RAW thumbnail bits in JPEG format or RGB format
                                       ; depends on PropertyTagThumbnailFormat

; Thumbnail related TAGs
PropertyTagThumbnailImageWidth         equ  5020h     ; Thumbnail width
PropertyTagThumbnailImageHeight        equ  5021h     ; Thumbnail height
PropertyTagThumbnailBitsPerSample      equ  5022h     ; Number of bits per component
PropertyTagThumbnailCompression        equ  5023h     ; Compression Scheme
PropertyTagThumbnailPhotometricInterp  equ  5024h     ; Pixel composition
PropertyTagThumbnailImageDescription   equ  5025h     ; Image Tile
PropertyTagThumbnailEquipMake          equ  5026h     ; Manufacturer of Image Input equipment
PropertyTagThumbnailEquipModel         equ  5027h     ; Model of Image input equipment
PropertyTagThumbnailStripOffsets       equ  5028h     ; Image data location
PropertyTagThumbnailOrientation        equ  5029h     ; Orientation of image
PropertyTagThumbnailSamplesPerPixel    equ  502Ah     ; Number of components
PropertyTagThumbnailRowsPerStrip       equ  502Bh     ; Number of rows per strip
PropertyTagThumbnailStripBytesCount    equ  502Ch     ; Bytes per compressed strip
PropertyTagThumbnailResolutionX        equ  502Dh     ; Resolution in width direction
PropertyTagThumbnailResolutionY        equ  502Eh     ; Resolution in height direction
PropertyTagThumbnailPlanarConfig       equ  502Fh     ; Image data arrangement
PropertyTagThumbnailResolutionUnit     equ  5030h     ; Unit of X and Y resolution
PropertyTagThumbnailTransferFunction   equ  5031h     ; Transfer function
PropertyTagThumbnailSoftwareUsed       equ  5032h     ; Software used
PropertyTagThumbnailDateTime           equ  5033h     ; File change date and time
PropertyTagThumbnailArtist             equ  5034h     ; Person who created the  image
PropertyTagThumbnailWhitePoint         equ  5035h     ; White point chromaticity
PropertyTagThumbnailPrimaryChromaticities   equ  5036h; Chromaticities of primaries
PropertyTagThumbnailYCbCrCoefficients  equ  5037h     ; Color space transformation coefficients
PropertyTagThumbnailYCbCrSubsampling   equ  5038h     ; Subsampling ratio of Y to C
PropertyTagThumbnailYCbCrPositioning   equ  5039h     ; Y and C position
PropertyTagThumbnailRefBlackWhite      equ  503Ah     ; Pair of black and white reference values
PropertyTagThumbnailCopyRight          equ  503Bh     ; CopyRight holder
PropertyTagLuminanceTable              equ  5090h
PropertyTagChrominanceTable            equ  5091h
PropertyTagFrameDelay                  equ  5100h
PropertyTagLoopCount                   equ  5101h
PropertyTagPixelUnit                   equ  5110h     ; Unit specifier for pixel/unit
PropertyTagPixelPerUnitX               equ  5111h     ; Pixels per unit in X
PropertyTagPixelPerUnitY               equ  5112h     ; Pixels per unit in Y
PropertyTagPaletteHistogram            equ  5113h     ; Palette histogram

; EXIF specific tag
PropertyTagExifExposureTime            equ  829Ah
PropertyTagExifFNumber                 equ  829Dh
PropertyTagExifExposureProg            equ  8822h
PropertyTagExifSpectralSense           equ  8824h
PropertyTagExifISOSpeed                equ  8827h
PropertyTagExifOECF                    equ  8828h
PropertyTagExifVer                     equ  9000h
PropertyTagExifDTOrig                  equ  9003h     ; Date & time of original
PropertyTagExifDTDigitized             equ  9004h     ; Date & time of digital data generation
PropertyTagExifCompConfig              equ  9101h
PropertyTagExifCompBPP                 equ  9102h
PropertyTagExifShutterSpeed            equ  9201h
PropertyTagExifAperture                equ  9202h
PropertyTagExifBrightness              equ  9203h
PropertyTagExifExposureBias            equ  9204h
PropertyTagExifMaxAperture             equ  9205h
PropertyTagExifSubjectDist             equ  9206h
PropertyTagExifMeteringMode            equ  9207h
PropertyTagExifLightSource             equ  9208h
PropertyTagExifFlash                   equ  9209h
PropertyTagExifFocalLength             equ  920Ah
PropertyTagExifMakerNote               equ  927Ch
PropertyTagExifUserComment             equ  9286h
PropertyTagExifDTSubsec                equ  9290h     ; Date & Time subseconds
PropertyTagExifDTOrigSS                equ  9291h     ; Date & Time original subseconds
PropertyTagExifDTDigSS                 equ  9292h     ; Date & TIme digitized subseconds
PropertyTagExifFPXVer                  equ  0A000h
PropertyTagExifColorSpace              equ  0A001h
PropertyTagExifPixXDim                 equ  0A002h
PropertyTagExifPixYDim                 equ  0A003h
PropertyTagExifRelatedWav              equ  0A004h    ; Related sound file
PropertyTagExifInterop                 equ  0A005h
PropertyTagExifFlashEnergy             equ  0A20Bh
PropertyTagExifSpatialFR               equ  0A20Ch    ; Spatial Frequency Response
PropertyTagExifFocalXRes               equ  0A20Eh    ; Focal Plane X Resolution
PropertyTagExifFocalYRes               equ  0A20Fh    ; Focal Plane Y Resolution
PropertyTagExifFocalResUnit            equ  0A210h    ; Focal Plane Resolution Unit
PropertyTagExifSubjectLoc              equ  0A214h
PropertyTagExifExposureIndex           equ  0A215h
PropertyTagExifSensingMethod           equ  0A217h
PropertyTagExifFileSource              equ  0A300h
PropertyTagExifSceneType               equ  0A301h
PropertyTagExifCfaPattern              equ  0A302h
PropertyTagGpsVer                      equ  0
PropertyTagGpsLatitudeRef              equ  1
PropertyTagGpsLatitude                 equ  2
PropertyTagGpsLongitudeRef             equ  3
PropertyTagGpsLongitude                equ  4
PropertyTagGpsAltitudeRef              equ  5
PropertyTagGpsAltitude                 equ  6
PropertyTagGpsGpsTime                  equ  7
PropertyTagGpsGpsSatellites            equ  8
PropertyTagGpsGpsStatus                equ  9
PropertyTagGpsGpsMeasureMode           equ  0Ah
PropertyTagGpsGpsDop                   equ  0Bh       ; Measurement precision
PropertyTagGpsSpeedRef                 equ  0Ch
PropertyTagGpsSpeed                    equ  0Dh
PropertyTagGpsTrackRef                 equ  0Eh
PropertyTagGpsTrack                    equ  0Fh
PropertyTagGpsImgDirRef                equ  10h
PropertyTagGpsImgDir                   equ  11h
PropertyTagGpsMapDatum                 equ  12h
PropertyTagGpsDestLatRef               equ  13h
PropertyTagGpsDestLat                  equ  14h
PropertyTagGpsDestLongRef              equ  15h
PropertyTagGpsDestLong                 equ  16h
PropertyTagGpsDestBearRef              equ  17h
PropertyTagGpsDestBear                 equ  18h
PropertyTagGpsDestDistRef              equ  19h
PropertyTagGpsDestDist                 equ  1Ah


 COLORBYTES  STRUC    ; OK   
  BlueByte   BYTE ?    
  GreenByte  BYTE ?   
  RedByte    BYTE ?   
  AlphaByte  BYTE ?
 COLORBYTES  ENDS

 COLORLONG  STRUC     ; OK
  longval   DWORD ?
 COLORLONG  ENDS 


ImageCodecInfo  STRUC
  ClassID            GUID  <>  
  FormatID           GUID  <>
  CodecName          DWORD ?                     ;  UNICODE  
  DllName            DWORD ?                     ;  UNICODE 
  FormatDescription  DWORD ?                     ;  UNICODE 
  FilenameExtension  DWORD ?                     ;  UNICODE 
  MimeType           DWORD ?                     ;  UNICODE 
  flags              DWORD ?   
  Version            DWORD ?   
  SigCount           DWORD ?
  SigSize            DWORD ?
  SigPattern         DWORD ?    
  SigMask            DWORD ?   
ImageCodecInfo  ENDS

 ;  Encoder Parameter
 ; ------------------------------------
                                       
 EncoderParameter  STRUC        ; OK             ; NOTE: pGUID is a GUID STRUCTURE
 pGUID             GUID <?>                      ; GUID 
 NumberOfValues    DWORD ?  
 vType             DWORD ?                       ; EncoderParameterValueType 
 value             DWORD ? 
 EncoderParameter  ENDS

 ; Encoder Parameters
 ; -------------------------------------

 EncoderParameters   STRUC      ; OK
  Count              DWORD ?    
  Parameter          EncoderParameter <>                                
 EncoderParameters   ENDS 

 ColorPalette  STRUC            ; OK 
  flags        DWORD ?  
  Count        DWORD ?       
  Entries      DWORD ?                
 ColorPalette  ENDS     

 ColorMatrix  STRUC             ; OK             
  m11         REAL4 ?    
  m12         REAL4 ?     
  m13         REAL4 ?
  m14         REAL4 ?
  m15         REAL4 ?
  m21         REAL4 ?
  m22         REAL4 ?
  m23         REAL4 ?
  m24         REAL4 ?
  m25         REAL4 ?
  m31         REAL4 ?
  m32         REAL4 ?
  m33         REAL4 ?
  m34         REAL4 ?
  m35         REAL4 ?
  m41         REAL4 ?
  m42         REAL4 ?
  m43         REAL4 ?
  m44         REAL4 ?
  m45         REAL4 ?
  m51         REAL4 ?
  m52         REAL4 ?
  m53         REAL4 ?
  m54         REAL4 ?
  m55         REAL4 ?
 ColorMatrix  ENDS 




 BitmapData    STRUC          ; OK                            
  nWIDTH       DWORD ?   
  nHeight      DWORD ?   
  stride       DWORD ?   
  PixelFormat  DWORD ?   
  scan0        DWORD ?   
  Reserved     DWORD ?
 BitmapData    ENDS

 PathData      STRUC          ; OK
  Count        DWORD ?   
  pPoint       DWORD ?            
  types        DWORD ?          
 PathData      ENDS

 PropertyItem  STRUC          ; OK 
  propId       DWORD ?   
  _length      DWORD ?    
  nType        WORD  ?          
  value        DWORD ?   
 PropertyItem  ENDS

 LOGFONTA           STRUC     ; OK
  lfHeight          DWORD ?   
  lfWidth           DWORD ?   
  lfEscapement      DWORD ?   
  lfOrientation     DWORD ?   
  lfWeight          DWORD ?   
  lfItalic          BYTE  ?   
  lfUnderline       BYTE  ?   
  lfStrikeOut       BYTE  ?   
  lfCharSet         BYTE  ?   
  lfOutPrecision    BYTE  ?   
  lfClipPrecision   BYTE  ?   
  lfQuality         BYTE  ?   
  lfPitchAndFamily  BYTE  ?   
  lfFaceName        BYTE  LF_FACESIZE dup(?)
 LOGFONTA           ENDS

 LOGFONTW           STRUC     ; OK
  lfHeight          DWORD ?   
  lfWidth           DWORD ?   
  lfEscapement      DWORD ?   
  lfOrientation     DWORD ?   
  lfWeight          DWORD ?   
  lfItalic          BYTE  ?   
  lfUnderline       BYTE  ?   
  lfStrikeOut       BYTE  ?   
  lfCharSet         BYTE  ?   
  lfOutPrecision    BYTE  ?   
  lfClipPrecision   BYTE  ?
  lfQuality         BYTE  ? 
  lfPitchAndFamily  BYTE  ?   
  lfFaceName        WORD  LF_FACESIZE dup(?)     ; TODO: Spruce this up a bit ???
 LOGFONTW           ENDS

 CharacterRange   STRUC            ; OK
  First           DWORD ?
  _length         DWORD ?
 CharacterRange   ENDS

 PWMFRect16   STRUC                ; OK
  nLEFT       WORD ? 
  nTop        WORD ?
  nRIGHT      WORD ?  
  nBottom     WORD ?
 PWMFRect16   ENDS

 WmfPlaceableFileHeader  STRUC     ; OK
  Key                    DWORD ?                 ; GDIP_WMF_PLACEABLEKEY   
  Hmf                    WORD  ? 
  boundingBox            PWMFRect16 <> 
  Inch                   WORD  ? 
  Reserved               DWORD ?
  Checksum               WORD  ? 
 WmfPlaceableFileHeader  ENDS

 ENHMETAHEADER3   STRUC            ; OK
  itype           DWORD ?                        ; EMR_HEADER   
  nSize           DWORD ?                        ; ENHMETAHEADER
  rclBounds       RECTL <> 
  rclFrame        RECTL <> 
  dSignature      DWORD ?                        ; ENHMETA_SIGNATURE.   
  nVersion        DWORD ?      
  nBytes          DWORD ?   
  nRecords        DWORD ?   
  nHandles        WORD  ?    
  sReserved       WORD  ?    
  nDescription    DWORD ?  
  offDescription  DWORD ?  
  nPalEntries     DWORD ?  
  szlDevice       SIZEL <>  
  szlMillimeters  SIZEL <>        
 ENHMETAHEADER3   ENDS

 MetafileHeader      STRUC         ; OK   
  mType              DWORD ?      
  msize              DWORD ?           
  Version            DWORD ?        
  EmfPlusFlags       DWORD ?   
  DpiX               REAL4 ?
  DpiY               REAL4 ?   
  x                  DWORD ?  
  y                  DWORD ?   
  nWIDTH             DWORD ?   
  Height             DWORD ?
  EmfHeader          ENHMETAHEADER3 <> 
  EmfPlusHeaderSize  DWORD ?       
  LogicalDpiX        DWORD ?     
  LogicalDpiY        DWORD ?  
 MetafileHeader      ENDS


; xzazet
;-----------------------------------------------
; GDI+ Enums
;-----------------------------------------------
UnitWorld          equ  0    ; World coordinate (non-physical unit)
UnitDisplay        equ  1    ; Variable -- for PageTransform only
UnitPixel          equ  2    ; Each unit is one device pixel.
UnitPoint          equ  3    ; Each unit is a printer's point, or 1/72 inch.
UnitInch           equ  4    ; Each unit is 1 inch.
UnitDocument       equ  5    ; Each unit is 1/300 inch.
UnitMillimeter     equ  6    ; Each unit is 1 millimeter.

; Common color constants
;[CHECKME]
; NOTE: Original enum was unnamed
ColorsAliceBlue              equ  0FFF0F8FFh
ColorsAntiqueWhite           equ  0FFFAEBD7h
ColorsAqua                   equ  0FF00FFFFh
ColorsAquamarine             equ  0FF7FFFD4h
ColorsAzure                  equ  0FFF0FFFFh
ColorsBeige                  equ  0FFF5F5DCh
ColorsBisque                 equ  0FFFFE4C4h
ColorsBlack                  equ  0FF000000h
ColorsBlanchedAlmond         equ  0FFFFEBCDh
ColorsBlue                   equ  0FF0000FFh
ColorsBlueViolet             equ  0FF8A2BE2h
ColorsBrown                  equ  0FFA52A2Ah
ColorsBurlyWood              equ  0FFDEB887h
ColorsCadetBlue              equ  0FF5F9EA0h
ColorsChartreuse             equ  0FF7FFF00h
ColorsChocolate              equ  0FFD2691Eh
ColorsCoral                  equ  0FFFF7F50h
ColorsCornflowerBlue         equ  0FF6495EDh
ColorsCornsilk               equ  0FFFFF8DCh
ColorsCrimson                equ  0FFDC143Ch
ColorsCyan                   equ  0FF00FFFFh
ColorsDarkBlue               equ  0FF00008Bh
ColorsDarkCyan               equ  0FF008B8Bh
ColorsDarkGoldenrod          equ  0FFB8860Bh
ColorsDarkGray               equ  0FFA9A9A9h
ColorsDarkGreen              equ  0FF006400h
ColorsDarkKhaki              equ  0FFBDB76Bh
ColorsDarkMagenta            equ  0FF8B008Bh
ColorsDarkOliveGreen         equ  0FF556B2Fh
ColorsDarkOrange             equ  0FFFF8C00h
ColorsDarkOrchid             equ  0FF9932CCh
ColorsDarkRed                equ  0FF8B0000h
ColorsDarkSalmon             equ  0FFE9967Ah
ColorsDarkSeaGreen           equ  0FF8FBC8Bh
ColorsDarkSlateBlue          equ  0FF483D8Bh
ColorsDarkSlateGray          equ  0FF2F4F4Fh
ColorsDarkTurquoise          equ  0FF00CED1h
ColorsDarkViolet             equ  0FF9400D3h
ColorsDeepPink               equ  0FFFF1493h
ColorsDeepSkyBlue            equ  0FF00BFFFh
ColorsDimGray                equ  0FF696969h
ColorsDodgerBlue             equ  0FF1E90FFh
ColorsFirebrick              equ  0FFB22222h
ColorsFloralWhite            equ  0FFFFFAF0h
ColorsForestGreen            equ  0FF228B22h
ColorsFuchsia                equ  0FFFF00FFh
ColorsGainsboro              equ  0FFDCDCDCh
ColorsGhostWhite             equ  0FFF8F8FFh
ColorsGold                   equ  0FFFFD700h
ColorsGoldenrod              equ  0FFDAA520h
ColorsGray                   equ  0FF808080h
ColorsGreen                  equ  0FF008000h
ColorsGreenYellow            equ  0FFADFF2Fh
ColorsHoneydew               equ  0FFF0FFF0h
ColorsHotPink                equ  0FFFF69B4h
ColorsIndianRed              equ  0FFCD5C5Ch
ColorsIndigo                 equ  0FF4B0082h
ColorsIvory                  equ  0FFFFFFF0h
ColorsKhaki                  equ  0FFF0E68Ch
ColorsLavender               equ  0FFE6E6FAh
ColorsLavenderBlush          equ  0FFFFF0F5h
ColorsLawnGreen              equ  0FF7CFC00h
ColorsLemonChiffon           equ  0FFFFFACDh
ColorsLightBlue              equ  0FFADD8E6h
ColorsLightCoral             equ  0FFF08080h
ColorsLightCyan              equ  0FFE0FFFFh
ColorsLightGoldenrodYellow   equ  0FFFAFAD2h
ColorsLightGray              equ  0FFD3D3D3h
ColorsLightGreen             equ  0FF90EE90h
ColorsLightPink              equ  0FFFFB6C1h
ColorsLightSalmon            equ  0FFFFA07Ah
ColorsLightSeaGreen          equ  0FF20B2AAh
ColorsLightSkyBlue           equ  0FF87CEFAh
ColorsLightSlateGray         equ  0FF778899h
ColorsLightSteelBlue         equ  0FFB0C4DEh
ColorsLightYellow            equ  0FFFFFFE0h
ColorsLime                   equ  0FF00FF00h
ColorsLimeGreen              equ  0FF32CD32h
ColorsLinen                  equ  0FFFAF0E6h
ColorsMagenta                equ  0FFFF00FFh
ColorsMaroon                 equ  0FF800000h
ColorsMediumAquamarine       equ  0FF66CDAAh
ColorsMediumBlue             equ  0FF0000CDh
ColorsMediumOrchid           equ  0FFBA55D3h
ColorsMediumPurple           equ  0FF9370DBh
ColorsMediumSeaGreen         equ  0FF3CB371h
ColorsMediumSlateBlue        equ  0FF7B68EEh
ColorsMediumSpringGreen      equ  0FF00FA9Ah
ColorsMediumTurquoise        equ  0FF48D1CCh
ColorsMediumVioletRed        equ  0FFC71585h
ColorsMidnightBlue           equ  0FF191970h
ColorsMintCream              equ  0FFF5FFFAh
ColorsMistyRose              equ  0FFFFE4E1h
ColorsMoccasin               equ  0FFFFE4B5h
ColorsNavajoWhite            equ  0FFFFDEADh
ColorsNavy                   equ  0FF000080h
ColorsOldLace                equ  0FFFDF5E6h
ColorsOlive                  equ  0FF808000h
ColorsOliveDrab              equ  0FF6B8E23h
ColorsOrange                 equ  0FFFFA500h
ColorsOrangeRed              equ  0FFFF4500h
ColorsOrchid                 equ  0FFDA70D6h
ColorsPaleGoldenrod          equ  0FFEEE8AAh
ColorsPaleGreen              equ  0FF98FB98h
ColorsPaleTurquoise          equ  0FFAFEEEEh
ColorsPaleVioletRed          equ  0FFDB7093h
ColorsPapayaWhip             equ  0FFFFEFD5h
ColorsPeachPuff              equ  0FFFFDAB9h
ColorsPeru                   equ  0FFCD853Fh
ColorsPink                   equ  0FFFFC0CBh
ColorsPlum                   equ  0FFDDA0DDh
ColorsPowderBlue             equ  0FFB0E0E6h
ColorsPurple                 equ  0FF800080h
ColorsRed                    equ  0FFFF0000h
ColorsRosyBrown              equ  0FFBC8F8Fh
ColorsRoyalBlue              equ  0FF4169E1h
ColorsSaddleBrown            equ  0FF8B4513h
ColorsSalmon                 equ  0FFFA8072h
ColorsSandyBrown             equ  0FFF4A460h
ColorsSeaGreen               equ  0FF2E8B57h
ColorsSeaShell               equ  0FFFFF5EEh
ColorsSienna                 equ  0FFA0522Dh
ColorsSilver                 equ  0FFC0C0C0h
ColorsSkyBlue                equ  0FF87CEEBh
ColorsSlateBlue              equ  0FF6A5ACDh
ColorsSlateGray              equ  0FF708090h
ColorsSnow                   equ  0FFFFFAFAh
ColorsSpringGreen            equ  0FF00FF7Fh
ColorsSteelBlue              equ  0FF4682B4h
ColorsTan                    equ  0FFD2B48Ch
ColorsTeal                   equ  0FF008080h
ColorsThistle                equ  0FFD8BFD8h
ColorsTomato                 equ  0FFFF6347h
ColorsTransparent            equ  0FFFFFFh
ColorsTurquoise              equ  0FF40E0D0h
ColorsViolet                 equ  0FFEE82EEh
ColorsWheat                  equ  0FFF5DEB3h
ColorsWhite                  equ  0FFFFFFFFh
ColorsWhiteSmoke             equ  0FFF5F5F5h
ColorsYellow                 equ  0FFFFFF00h
ColorsYellowGreen            equ  0FF9ACD32h


;' NOTE: Enums evaluate to a Long
GpStatusOk                        equ  0
GpStatusGenericError              equ  1
GpStatusInvalidParameter          equ  2
GpStatusOutOfMemory               equ  3
GpStatusObjectBusy                equ  4
GpStatusInsufficientBuffer        equ  5
GpStatusNotImplemented            equ  6
GpStatusWin32Error                equ  7
GpStatusWrongState                equ  8
GpStatusAborted                   equ  9
GpStatusFileNotFound              equ  10
GpStatusValueOverflow             equ  11
GpStatusAccessDenied              equ  12
GpStatusUnknownImageFormat        equ  13
GpStatusFontFamilyNotFound        equ  14
GpStatusFontStyleNotFound         equ  15
GpStatusNotTrueTypeFont           equ  16
GpStatusUnsupportedGdiplusVersion equ  17
GpStatusGdiplusNotInitialized     equ  18
GpStatusPropertyNotFound          equ  19
GpStatusPropertyNotSupported      equ  20

; Quality mode constants
QualityModeInvalid                equ  -1
QualityModeDefault                equ  0
QualityModeLow                    equ  1    ; Best performance
QualityModeHigh                   equ  2    ; Best rendering quality

; Alpha Compositing mode constants
CompositingModeSourceOver         equ  0
CompositingModeSourceCopy         equ  1

; Alpha Compositing quality constants
CompositingQualityInvalid         equ  QualityModeInvalid
CompositingQualityDefault         equ  QualityModeDefault
CompositingQualityHighSpeed       equ  QualityModeLow
CompositingQualityHighQuality     equ  QualityModeHigh
CompositingQualityGammaCorrected  equ  3
CompositingQualityAssumeLinear    equ  4

; Generic font families
GenericFontFamilySerif            equ  0
GenericFontFamilySansSerif        equ  1
GenericFontFamilyMonospace        equ  2

; FontStyle: face types and common styles
FontStyleRegular                  equ  0
FontStyleBold                     equ  1
FontStyleItalic                   equ  2
FontStyleBoldItalic               equ  3
FontStyleUnderline                equ  4
FontStyleStrikeout                equ  8
SmoothingModeInvalid              equ  QualityModeInvalid
SmoothingModeDefault              equ  QualityModeDefault
SmoothingModeHighSpeed            equ  QualityModeLow
SmoothingModeHighQuality          equ  QualityModeHigh
SmoothingModeNone                 equ  3
SmoothingModeAntiAlias            equ  4
FillModeAlternate                 equ  0
FillModeWinding                   equ  1
InterpolationModeInvalid          equ  QualityModeInvalid
InterpolationModeDefault          equ  QualityModeDefault
InterpolationModeLowQuality       equ  QualityModeLow
InterpolationModeHighQuality      equ  QualityModeHigh
InterpolationModeBilinear         equ  3
InterpolationModeBicubic          equ  4
InterpolationModeNearestNeighbor  equ  5
InterpolationModeHighQualityBilinear   equ  6
InterpolationModeHighQualityBicubic    equ  7

; Various wrap modes for brushes
WrapModeTile                      equ  0
WrapModeTileFlipX                 equ  1
WrapModeTileFlipY                 equ  2
WrapModeTileFlipXY                equ  3
WrapModeClamp                     equ  4
LinearGradientModeHorizontal      equ  0
LinearGradientModeVertical        equ  1
LinearGradientModeForwardDiagonal equ  2
LinearGradientModeBackwardDiagonal equ 3
ImageTypeUnknown                  equ  0
ImageTypeBitmap                   equ  1
ImageTypeMetafile                 equ  2


;----------------------------

 HatchStyleHorizontal                  EQU  0
 HatchStyleVertical                    EQU  1
 HatchStyleForwardDiagonal             EQU  2
 HatchStyleBackwardDiagonal            EQU  3
 HatchStyleCross                       EQU  4
 HatchStyleDiagonalCross               EQU  5
 HatchStyle05Percent                   EQU  6
 HatchStyle10Percent                   EQU  7
 HatchStyle20Percent                   EQU  8
 HatchStyle25Percent                   EQU  9
 HatchStyle30Percent                   EQU  10
 HatchStyle40Percent                   EQU  11
 HatchStyle50Percent                   EQU  12
 HatchStyle60Percent                   EQU  13
 HatchStyle70Percent                   EQU  14
 HatchStyle75Percent                   EQU  15
 HatchStyle80Percent                   EQU  16
 HatchStyle90Percent                   EQU  17
 HatchStyleLightDownwardDiagonal       EQU  18
 HatchStyleLightUpwardDiagonal         EQU  19
 HatchStyleDarkDownwardDiagonal        EQU  20
 HatchStyleDarkUpwardDiagonal          EQU  21
 HatchStyleWideDownwardDiagonal        EQU  22
 HatchStyleWideUpwardDiagonal          EQU  23
 HatchStyleLightVertical               EQU  24
 HatchStyleLightHorizontal             EQU  25
 HatchStyleNarrowVertical              EQU  26
 HatchStyleNarrowHorizontal            EQU  27
 HatchStyleDarkVertical                EQU  28
 HatchStyleDarkHorizontal              EQU  29
 HatchStyleDashedDownwardDiagonal      EQU  30
 HatchStyleDashedUpwardDiagonal        EQU  31
 HatchStyleDashedHorizontal            EQU  32
 HatchStyleDashedVertical              EQU  33
 HatchStyleSmallConfetti               EQU  34
 HatchStyleLargeConfetti               EQU  35
 HatchStyleZigZag                      EQU  36
 HatchStyleWave                        EQU  37
 HatchStyleDiagonalBrick               EQU  38
 HatchStyleHorizontalBrick             EQU  39
 HatchStyleWeave                       EQU  40
 HatchStylePlaid                       EQU  41
 HatchStyleDivot                       EQU  42 
 HatchStyleDottedGrid                  EQU  43
 HatchStyleDottedDiamond               EQU  44
 HatchStyleShingle                     EQU  45
 HatchStyleTrellis                     EQU  46 
 HatchStyleSphere                      EQU  47
 HatchStyleSmallGrid                   EQU  48
 HatchStyleSmallCheckerBoard           EQU  49
 HatchStyleLargeCheckerBoard           EQU  50
 HatchStyleOutlinedDiamond             EQU  51
 HatchStyleSolidDiamond                EQU  52
 HatchStyleTotal                       EQU  53
 HatchStyleLargeGrid                   EQU  HatchStyleCross
 HatchStyleMin                         EQU  HatchStyleHorizontal
 HatchStyleMax                         EQU  HatchStyleTotal - 1

 ; Matrix
 ;------------------

 MatrixOrderPrepend                    EQU  0
 MatrixOrderAppend                     EQU  1

 ; Color
 ; -----------------

 ColorAdjustTypeDefault                EQU  0
 ColorAdjustTypeBitmap                 EQU  1
 ColorAdjustTypeBrush                  EQU  2
 ColorAdjustTypePen                    EQU  3
 ColorAdjustTypeText                   EQU  4
 ColorAdjustTypeCount                  EQU  5
 ColorAdjustTypeAny                    EQU  6  ; Reserved

 ColorChannelFlagsC                    EQU  0 
 ColorChannelFlagsM                    EQU  1 
 ColorChannelFlagsY                    EQU  2
 ColorChannelFlagsK                    EQU  3
 ColorChannelFlagsLast                 EQU  4

 ColorMatrixFlagsDefault               EQU  0
 ColorMatrixFlagsSkipGrays             EQU  1
 ColorMatrixFlagsAltGray               EQU  2

 ; Pen 
 ; --------------

 PenAlignmentCenter                    EQU  0
 PenAlignmentInset                     EQU  1

 ; Brush 
 ; ----------------

 BrushTypeSolidColor                   EQU  0
 BrushTypeHatchFill                    EQU  1
 BrushTypeTextureFill                  EQU  2
 BrushTypePathGradient                 EQU  3
 BrushTypeLinearGradient               EQU  4

 ; Dash
 ; --------------

 DashStyleSolid                        EQU  0
 DashStyleDash                         EQU  1
 DashStyleDot                          EQU  2
 DashStyleDashDot                      EQU  3
 DashStyleDashDotDot                   EQU  4
 DashStyleCustom                       EQU  5  
 
 ; Dash cap constants
 ;--------------------
 ; Line cap

 DashCapFlat                           EQU  0
 DashCapRound                          EQU  2
 DashCapTriangle                       EQU  3

 LineCapFlat                           EQU  0
 LineCapSquare                         EQU  1
 LineCapRound                          EQU  2
 LineCapTriangle                       EQU  3
 LineCapNoAnchor                       EQU  010h     ; corresponds to flat cap
 LineCapSquareAnchor                   EQU  011h     ; corresponds to square cap
 LineCapRoundAnchor                    EQU  012h     ; corresponds to round cap
 LineCapDiamondAnchor                  EQU  013h     ; corresponds to triangle cap
 LineCapArrowAnchor                    EQU  014h     ; no correspondence
 LineCapCustom                         EQU  0FFh     ; custom cap
 LineCapAnchorMask                     EQU  0F0h     ; mask to check for anchor or not.

 ; Custom Line cap type
 ;--------------------------------

 CustomLineCapTypeDefault              EQU  0
 CustomLineCapTypeAdjustableArrow      EQU  1        

 ; Line join
 ; --------------------

 LineJoinMiter                         EQU  0
 LineJoinBevel                         EQU  1
 LineJoinRound                         EQU  2
 LineJoinMiterClipped                  EQU  3

 ; Pen's Fill
 ; --------------------

 PenTypeSolidColor                     EQU  BrushTypeSolidColor
 PenTypeHatchFill                      EQU  BrushTypeHatchFill
 PenTypeTextureFill                    EQU  BrushTypeTextureFill
 PenTypePathGradient                   EQU  BrushTypePathGradient
 PenTypeLinearGradient                 EQU  BrushTypeLinearGradient
 PenTypeUnknown                        EQU  -1

 ; Warp Mode
 ; -----------

 WarpModePerspective                   EQU  0
 WarpModeBilinear                      EQU  1

 ; Region 
 ; -----------------------------

 CombineModeReplace                    EQU  0
 CombineModeIntersect                  EQU  1
 CombineModeUnion                      EQU  2
 CombineModeXor                        EQU  3
 CombineModeExclude                    EQU  4
 CombineModeComplement                 EQU  5 

 RotateNoneFlipNone                    EQU  0
 Rotate90FlipNone                      EQU  1
 Rotate180FlipNone                     EQU  2
 Rotate270FlipNone                     EQU  3
 RotateNoneFlipX                       EQU  4
 Rotate90FlipX                         EQU  5
 Rotate180FlipX                        EQU  6
 Rotate270FlipX                        EQU  7
 RotateNoneFlipY                       EQU  Rotate180FlipX
 Rotate90FlipY                         EQU  Rotate270FlipX
 Rotate180FlipY                        EQU  RotateNoneFlipX
 Rotate270FlipY                        EQU  Rotate90FlipX
 RotateNoneFlipXY                      EQU  Rotate180FlipNone
 Rotate90FlipXY                        EQU  Rotate270FlipNone
 Rotate180FlipXY                       EQU  RotateNoneFlipNone
 Rotate270FlipXY                       EQU  Rotate90FlipNone



; DirectionRightToLeft - the base embedding level by the Unicode
;                        bidirectional engine.

; DirectionVertical    - 

; NoFitBlackBox        - Allows parts of glyphs to overhang the
;                        bounding rectangle.
;                        By default glyphs are first aligned
;                        inside the margines, then any glyphs which
;                        still overhang the bounding box are
;                        repositioned to avoid any overhang.
;                        For example when an italic
;                        lower case letter f in a font such as
;                        Garamond is aligned at the far left of a
;                        rectangle, the lower part of the f will
;                        reach slightly further left than the left
;                        edge of the rectangle. Setting this flag
;                        will ensure the character aligns visually
;                        with the lines above and below, but may
;                        cause some pixels outside the formatting
;                        rectangle to be clipped or painted.
;
; DisplayFormatControl - Causes control characters such as the
;                        left-to-right mark to be shown in the
;                        output with a representative glyph.
;
; NoFontFallback       - Disables fallback to alternate fonts for
;                        characters not supported in the requested
;                        font. Any missing characters will be
;                        be displayed with the fonts missing glyph,
;                        usually an open square.
;
; NoWrap               - Disables wrapping of text between lines
;                        when formatting within a rectangle.
;                        NoWrap is implied when a point is passed
;                        instead of a rectangle, or when the
;                        specified rectangle has a zero line length.
;
; NoClip               - By default text is clipped to the
;                        formatting rectangle. Setting NoClip
;                        allows overhanging pixels to affect the
;                        device outside the formatting rectangle.
;                        Pixels at the end of the line may be
;                        affected if the glyphs overhang their
;                        cells, and either the NoFitBlackBox flag
;                        has been set, or the glyph extends to far
;                        to be fitted.
;                        if the glyphs extend beyond their cell
;                        ascent / descent. This can occur rarely
;                        with unusual diacritic mark combinations.

 StringFormatFlagsDirectionRightToLeft   EQU  01h
 StringFormatFlagsDirectionVertical      EQU  02h
 StringFormatFlagsNoFitBlackBox          EQU  04h
 StringFormatFlagsDisplayFormatControl   EQU  020h
 StringFormatFlagsNoFontFallback         EQU  0400h
 StringFormatFlagsMeasureTrailingSpaces  EQU  0800h
 StringFormatFlagsNoWrap                 EQU  01000h
 StringFormatFlagsLineLimit              EQU  02000h

 StringFormatFlagsNoClip                 EQU  04000h

 StringTrimmingNone                      EQU  0
 StringTrimmingCharacter                 EQU  1
 StringTrimmingWord                      EQU  2
 StringTrimmingEllipsisCharacter         EQU  3
 StringTrimmingEllipsisWord              EQU  4
 StringTrimmingEllipsisPath              EQU  5

 ; National language digit substitution
 ; -------------------------------------

 StringDigitSubstituteUser               EQU  0 
 StringDigitSubstituteNone               EQU  1
 StringDigitSubstituteNational           EQU  2
 StringDigitSubstituteTraditional        EQU  3

 ; Hotkey prefix interpretation
 ; ------------------------------

 HotkeyPrefixNone                        EQU  0
 HotkeyPrefixShow                        EQU  1
 HotkeyPrefixHide                        EQU  2

 ; Left edge for left-to-right text,
 ; right for right-to-left text,
 ; and top for vertical

 StringAlignmentNear                     EQU  0
 StringAlignmentCenter                   EQU  1
 StringAlignmentFar                      EQU  2

 FlushIntentionFlush                     EQU  0     ; Flush all batched rendering operations
 FlushIntentionSync                      EQU  1     ; Flush all batched rendering operations
                                                    ; and wait for them to complete
                                                    ; Image encoder parameter related types

 EncoderParameterValueTypeByte           EQU  1     ; 8-bit int
 EncoderParameterValueTypeASCII          EQU  2     ; 8-bit byte  7-bit ASCII
                                                    ;  NULL .

 EncoderParameterValueTypeShort          EQU  3     ; 16-bit  int
 EncoderParameterValueTypeLong           EQU  4     ; 32-bit  int
 EncoderParameterValueTypeRational       EQU  5     ; Long

 EncoderParameterValueTypeLongRange      EQU  6  


 EncoderParameterValueTypeUndefined      EQU  7     ; 8-bit byte that can take any value
                                                    ; depending on field definition

 EncoderParameterValueTypeRationalRange  EQU  8     ; Two Rationals. The first Rational
                                                    ; specifies the lower end and the second
                                                    ; specifies the higher end. All values
                                                    ; are inclusive at both ends
 ; Image encoder value types
 ; ----------------------------

 EncoderValueColorTypeCMYK               EQU  0
 EncoderValueColorTypeYCCK               EQU  1
 EncoderValueCompressionLZW              EQU  2
 EncoderValueCompressionCCITT3           EQU  3
 EncoderValueCompressionCCITT4           EQU  4
 EncoderValueCompressionRle              EQU  5
 EncoderValueCompressionNone             EQU  6
 EncoderValueScanMethodInterlaced        EQU  7
 EncoderValueScanMethodNonInterlaced     EQU  8
 EncoderValueVersionGif87                EQU  9
 EncoderValueVersionGif89                EQU  10
 EncoderValueRenderProgressive           EQU  11
 EncoderValueRenderNonProgressive        EQU  12
 EncoderValueTransformRotate90           EQU  13
 EncoderValueTransformRotate180          EQU  14
 EncoderValueTransformRotate270          EQU  15
 EncoderValueTransformFlipHorizontal     EQU  16
 EncoderValueTransformFlipVertical       EQU  17
 EncoderValueMultiFrame                  EQU  18
 EncoderValueLastFrame                   EQU  19
 EncoderValueFlush                       EQU  20
 EncoderValueFrameDimensionTime          EQU  21
 EncoderValueFrameDimensionResolution    EQU  22
 EncoderValueFrameDimensionPage          EQU  23


 EncoderCompression                      EQU  0
 EncoderColorDepth                       EQU  1
 EncoderScanMethod                       EQU  2
 EncoderVersion                          EQU  3
 EncoderRenderMethod                     EQU  4
 EncoderQuality                          EQU  5
 EncoderTransformation                   EQU  6
 EncoderLuminanceTable                   EQU  7
 EncoderChrominanceTable                 EQU  8
 EncoderSaveFlag                         EQU  9

 PixelOffsetModeInvalid                  EQU  QualityModeInvalid
 PixelOffsetModeDefault                  EQU  QualityModeDefault
 PixelOffsetModeHighSpeed                EQU  QualityModeLow
 PixelOffsetModeHighQuality              EQU  QualityModeHigh
 PixelOffsetModeNone                     EQU  3
 PixelOffsetModeHalf                     EQU  4 

 TextRenderingHintSystemDefault             EQU  0     ; Glyph with system default rendering hint
 TextRenderingHintSingleBitPerPixelGridFit  EQU  1     ; Glyph bitmap with hinting
 TextRenderingHintSingleBitPerPixel         EQU  2     ; Glyph bitmap without hinting
 TextRenderingHintAntiAliasGridFit          EQU  3     ; Glyph anti-alias bitmap with hinting
 TextRenderingHintAntiAlias                 EQU  4     ; Glyph anti-alias bitmap without hinting
 TextRenderingHintClearTypeGridFit          EQU  5     ; Glyph CT bitmap with hinting

 MetafileTypeInvalid                        EQU  0 
 MetafileTypeWmf                            EQU  1     ; WMF
 MetafileTypeWmfPlaceable                   EQU  2     ; Placeable WMF
 MetafileTypeEmf                            EQU  3     ; EMF
 MetafileTypeEmfPlusOnly                    EQU  4     ; EMF+
 MetafileTypeEmfPlusDual                    EQU  5     ; EMF+

 ; Specifies the type of EMF to record
 ; -------------------------------------

 EmfTypeEmfOnly                             EQU  MetafileTypeEmf  
 EmfTypeEmfPlusOnly                         EQU  MetafileTypeEmfPlusOnly 
 EmfTypeEmfPlusDual                         EQU  MetafileTypeEmfPlusDual 

 ; EMF+ Persistent object types
 ; --------------------------------------
 
 ObjectTypeInvalid                          EQU  0
 ObjectTypeBrush                            EQU  1
 ObjectTypePen                              EQU  2
 ObjectTypePath                             EQU  3
 ObjectTypeRegion                           EQU  4
 ObjectTypeImage                            EQU  5
 ObjectTypeFont                             EQU  6
 ObjectTypeStringFormat                     EQU  7
 ObjectTypeImageAttributes                  EQU  8
 ObjectTypeCustomLineCap                    EQU  9

 ObjectTypeMax                              EQU  ObjectTypeCustomLineCap
 ObjectTypeMin                              EQU  ObjectTypeBrush

 ; frameRect
 ; There is an extra frame unit value (MetafileFrameUnitGdi) so
 ; that units can be supplied in the same units that GDI expects for
 ; frame rects -- these units are in .01 (1/100ths) millimeter units
 ; as defined by GDI.
 
 MetafileFrameUnitPixel                     EQU  UnitPixel
 MetafileFrameUnitPoint                     EQU  UnitPoint
 MetafileFrameUnitInch                      EQU  UnitInch
 MetafileFrameUnitDocument                  EQU  UnitDocument
 MetafileFrameUnitMillimeter                EQU  UnitMillimeter
 MetafileFrameUnitGdi                       EQU  7 

 ; Coordinate space identifiers
 ; -----------------------------

 CoordinateSpaceWorld                       EQU  0
 CoordinateSpacePage                        EQU  1
 CoordinateSpaceDevice                      EQU  2

;         DRAW IMAGE

; gpGraphics, gpImage, x:REAL4, Y:REAL4
GdipDrawImage PROTO :DWORD,:DWORD,:DWORD,:DWORD

; gpGraphics, gpImage, x:DWORD, Y:DWORD
GdipDrawImageI PROTO :DWORD,:DWORD,:DWORD,:DWORD

; gpGraphics, gpImage, x:REAL4, Y:REAL4, srcx:REAL4, srcy:REAL4, srcwidth:REAL4, srcheight:REAL4, srcUnit:GpUnit
GdipDrawImagePointRect PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

; gpGraphics, gpImage, x:DWORD, Y:DWORD, srcx:DWORD, srcy:DWORD, srcwidth:DWORD, srcheight:DWORD, srcUnit:GpUnit
GdipDrawImagePointRectI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;  gpGraphics, gpImage, dstpoints:POINTF, count:DWORD
GdipDrawImagePoints PROTO :DWORD,:DWORD,:DWORD,:DWORD

; gpGraphics, gpImage, dstpoints:POINTL, count:DWORD
GdipDrawImagePointsI PROTO :DWORD,:DWORD,:DWORD,:DWORD

;gpGraphics, gpImage, Points:POINTF, count:DWORD, srcx:REAL4, srcy:REAL4, srcwidth:REAL4, srcheight:REAL4, srcUnit:GpUnit, Optional imageAttributes:DWORD = 0, Optional callback:DWORD = 0, Optional callbackData:DWORD = 0
GdipDrawImagePointsRect PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;gpGraphics, gpImage, Points:POINTL, count:DWORD, srcx:DWORD, srcy:DWORD, srcwidth:DWORD, srcheight:DWORD, srcUnit:GpUnit, Optional imageAttributes:DWORD = 0, Optional callback:DWORD = 0, Optional callbackData:DWORD = 0
GdipDrawImagePointsRectI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;gpGraphics, gpImage, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4
GdipDrawImageRect PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;gpGraphics, gpImage, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD
GdipDrawImageRectI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;gpGraphics, gpImage, dstx:REAL4, dsty:REAL4, dstwidth:DWORD, dstheight:REAL4, srcx:REAL4, srcy:REAL4, srcwidth:REAL4, srcheight:REAL4, srcUnit:GpUnit, Optional imageAttributes:DWORD = 0, Optional callback:DWORD = 0, Optional callbackData:DWORD = 0
GdipDrawImageRectRect PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;gpGraphics, gpImage, dstx:DWORD, dsty:DWORD, dstwidth:DWORD, dstheight:DWORD, srcx:DWORD, srcy:DWORD, srcwidth:DWORD, srcheight:DWORD, srcUnit:GpUnit, Optional imageAttributes:DWORD = 0, Optional callback:DWORD = 0, Optional callbackData:DWORD = 0
GdipDrawImageRectRectI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD


;   THUMBNAIL
;gpImage, thumbWidth:DWORD, thumbHeight:DWORD, thumbgpImage, Optional callback:DWORD = 0, Optional callbackData:DWORD = 0
GdipGetImageThumbnail PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD




;   CREATE  GRAPHIC
;GdipCreateFromHDC  hdc:DWORD, addr gpGraphics
GdipCreateFromHDC PROTO :DWORD,:DWORD

GdipCreateFromHDC2 PROTO :DWORD,:DWORD,:DWORD

;GdipCreateFromHWND  hwnd:DWORD, addr gpGraphics
GdipCreateFromHWND PROTO :DWORD,:DWORD

;GdipCreateFromHWNDICM  hwnd:DWORD, addr gpGraphics
GdipCreateFromHWNDICM PROTO :DWORD,:DWORD


;GdipCreateImageAttributes  imageattr:DWORD
GdipCreateImageAttributes PROTO :DWORD

;    LOAD  IMAGE
;GdipLoadImageFromFile  Filename:String, image:DWORD
GdipLoadImageFromFile PROTO :DWORD,:DWORD

;GdipLoadImageFromFileICM  Filename:String, image:DWORD
GdipLoadImageFromFileICM PROTO :DWORD,:DWORD

;GdipLoadImageFromStream  stream:IStream, image:DWORD
GdipLoadImageFromStream PROTO :DWORD,:DWORD

;GdipLoadImageFromStreamICM  stream:IStream, image:DWORD
GdipLoadImageFromStreamICM PROTO :DWORD,:DWORD


;		GET  IMAGE
;GdipGetImageAttributesAdjustedPalette  imageattr:DWORD, colorPal:ColorPalette, ClrAdjType:ColorAdjustType
GdipGetImageAttributesAdjustedPalette PROTO :DWORD,:DWORD,:DWORD

;GdipGetImageBounds  image:DWORD, srcRect:RECTF, srcUnit:GpUnit
GdipGetImageBounds PROTO :DWORD,:DWORD,:DWORD

;GdipGetImageDecoders  numDecoders:DWORD, SIZE:DWORD, decoders:Any
GdipGetImageDecoders PROTO :DWORD,:DWORD,:DWORD

;GdipGetImageDecodersSize  numDecoders:DWORD, SIZE:DWORD
GdipGetImageDecodersSize PROTO :DWORD,:DWORD

;GdipGetImageDimension  image:DWORD, Width:REAL4, Height:REAL4
GdipGetImageDimension PROTO :DWORD,:DWORD,:DWORD

;GdipGetImageEncoders  numEncoders:DWORD, SIZE:DWORD, encoders:Any
GdipGetImageEncoders PROTO :DWORD,:DWORD,:DWORD

;GdipGetImageEncodersSize  numEncoders:DWORD, SIZE:DWORD
GdipGetImageEncodersSize PROTO :DWORD,:DWORD

;GdipGetImageFlags  image:DWORD, Flags:DWORD
GdipGetImageFlags PROTO :DWORD,:DWORD

;GdipGetImageGraphicsContext  image:DWORD, graphics:DWORD
GdipGetImageGraphicsContext PROTO :DWORD,:DWORD

;GdipGetImageHeight  image:DWORD, Height:DWORD
GdipGetImageHeight PROTO :DWORD,:DWORD

;GdipGetImageHorizontalResolution  image:DWORD, resolution:REAL4
GdipGetImageHorizontalResolution PROTO :DWORD,:DWORD

GdipGetImageLayout PROTO :DWORD,:DWORD

;GdipGetImagePalette  image:DWORD, palette:ColorPalette, SIZE:DWORD
GdipGetImagePalette PROTO :DWORD,:DWORD,:DWORD

;GdipGetImagePaletteSize  image:DWORD, SIZE:DWORD
GdipGetImagePaletteSize PROTO :DWORD,:DWORD

;GdipGetImagePixelFormat  image:DWORD, PixelFormat:DWORD
GdipGetImagePixelFormat PROTO :DWORD,:DWORD

;GdipGetImageRawFormat  image:DWORD, format:CLSID
GdipGetImageRawFormat PROTO :DWORD,:DWORD


;GdipGetImageType  image:DWORD, itype:ImageType
GdipGetImageType PROTO :DWORD,:DWORD

;GdipGetImageVerticalResolution  image:DWORD, resolution:REAL4
GdipGetImageVerticalResolution PROTO :DWORD,:DWORD

;GdipGetImageWidth  image:DWORD, Width:DWORD
GdipGetImageWidth PROTO :DWORD,:DWORD





; 		PROPERTY

;GdipGetPropertyCount  image:DWORD, numOfProperty:DWORD
GdipGetPropertyCount PROTO :DWORD,:DWORD

;GdipGetPropertyIdList  image:DWORD, numOfProperty:DWORD, list:DWORD
GdipGetPropertyIdList PROTO :DWORD,:DWORD,:DWORD

;GdipGetPropertyItem  image:DWORD, propId:DWORD, propSize:DWORD, buffer:PropertyItem
GdipGetPropertyItem PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipGetPropertyItemSize  image:DWORD, propId:DWORD, SIZE:DWORD
GdipGetPropertyItemSize PROTO :DWORD,:DWORD,:DWORD

;GdipGetPropertySize  image:DWORD, totalBufferSize:DWORD, numProperties:DWORD
GdipGetPropertySize PROTO :DWORD,:DWORD,:DWORD

;GdipGetAllPropertyItems  image:DWORD, totalBufferSize:DWORD, numProperties:DWORD, allItems:PropertyItem
GdipGetAllPropertyItems PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipRemovePropertyItem  image:DWORD, propId:DWORD
GdipRemovePropertyItem PROTO :DWORD,:DWORD

;GdipSetPropertyItem  image:DWORD, item:PropertyItem
GdipSetPropertyItem PROTO :DWORD,:DWORD







GdipAddImageCodec PROTO :DWORD

;GdipAddPathArc  path:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4, startAngle:REAL4, sweepAngle:REAL4
GdipAddPathArc PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathArcI  path:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD, startAngle:REAL4, sweepAngle:REAL4
GdipAddPathArcI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathBezier  path:DWORD, X1:REAL4, Y1:REAL4, X2:REAL4, Y2:REAL4, X3:REAL4, Y3:REAL4, x4:REAL4, y4:REAL4
GdipAddPathBezier PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathBezierI  path:DWORD, X1:DWORD, Y1:DWORD, X2:DWORD, Y2:DWORD, X3:DWORD, Y3:DWORD, x4:DWORD, y4:DWORD
GdipAddPathBezierI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathBeziers  path:DWORD, Points:POINTF, count:DWORD
GdipAddPathBeziers PROTO :DWORD,:DWORD,:DWORD

;GdipAddPathBeziersI  path:DWORD, Points:POINTL, count:DWORD
GdipAddPathBeziersI PROTO :DWORD,:DWORD,:DWORD

;GdipAddPathClosedCurve  path:DWORD, Points:POINTF, count:DWORD
GdipAddPathClosedCurve PROTO :DWORD,:DWORD,:DWORD

;GdipAddPathClosedCurve2  path:DWORD, Points:POINTF, count:DWORD, tension:REAL4
GdipAddPathClosedCurve2 PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathClosedCurve2I  path:DWORD, Points:POINTL, count:DWORD, tension:REAL4
GdipAddPathClosedCurve2I PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathClosedCurveI  path:DWORD, Points:POINTL, count:DWORD
GdipAddPathClosedCurveI PROTO :DWORD,:DWORD,:DWORD

;GdipAddPathCurve  path:DWORD, Points:POINTF, count:DWORD
GdipAddPathCurve PROTO :DWORD,:DWORD,:DWORD

;GdipAddPathCurve2  path:DWORD, Points:POINTF, count:DWORD, tension:REAL4
GdipAddPathCurve2 PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathCurve2I  path:DWORD, Points:POINTL, count:DWORD, tension:DWORD
GdipAddPathCurve2I PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathCurve3  path:DWORD, Points:POINTF, count:DWORD, Offset:DWORD, numberOfSegments:DWORD, tension:REAL4
GdipAddPathCurve3 PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathCurve3I  path:DWORD, Points:POINTL, count:DWORD, Offset:DWORD, numberOfSegments:DWORD, tension:REAL4
GdipAddPathCurve3I PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathCurveI  path:DWORD, Points:POINTL, count:DWORD
GdipAddPathCurveI PROTO :DWORD,:DWORD,:DWORD

;GdipAddPathEllipse  path:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4
GdipAddPathEllipse PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathEllipseI  path:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD
GdipAddPathEllipseI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathLine  path:DWORD, X1:REAL4, Y1:REAL4, X2:REAL4, Y2:REAL4
GdipAddPathLine PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathLine2  path:DWORD, Points:POINTF, count:DWORD
GdipAddPathLine2 PROTO :DWORD,:DWORD,:DWORD

;GdipAddPathLine2I  path:DWORD, Points:POINTL, count:DWORD
GdipAddPathLine2I PROTO :DWORD,:DWORD,:DWORD

;GdipAddPathLineI  path:DWORD, X1:DWORD, Y1:DWORD, X2:DWORD, Y2:DWORD
GdipAddPathLineI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathPath  path:DWORD, addingPath:DWORD, bConnect:DWORD
GdipAddPathPath PROTO :DWORD,:DWORD,:DWORD

;GdipAddPathPie  path:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4, startAngle:REAL4, sweepAngle:REAL4
GdipAddPathPie PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathPieI  path:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD, startAngle:REAL4, sweepAngle:REAL4
GdipAddPathPieI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathPolygon  path:DWORD, Points:POINTF, count:DWORD
GdipAddPathPolygon PROTO :DWORD,:DWORD,:DWORD

;GdipAddPathPolygonI  path:DWORD, Points:POINTL, count:DWORD
GdipAddPathPolygonI PROTO :DWORD,:DWORD,:DWORD

;GdipAddPathRectangle  path:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4
GdipAddPathRectangle PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathRectangleI  path:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD
GdipAddPathRectangleI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathRectangles  path:DWORD, RECT:RECTF, count:DWORD
GdipAddPathRectangles PROTO :DWORD,:DWORD,:DWORD

;GdipAddPathRectanglesI  path:DWORD, rects:RECTL, count:DWORD
GdipAddPathRectanglesI PROTO :DWORD,:DWORD,:DWORD

;GdipAddPathString  path:DWORD, str:String, Length:DWORD, family:DWORD, Style:DWORD, emSize:REAL4, layoutRect:RECTF, StringFormat:DWORD
GdipAddPathString PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAddPathStringI  path:DWORD, str:String, Length:DWORD, family:DWORD, Style:DWORD, emSize:REAL4, layoutRect:RECTL, StringFormat:DWORD
GdipAddPathStringI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipAlloc  SIZE:DWORD
GdipAlloc PROTO :DWORD

;GdipBeginContainer  graphics:DWORD, dstrect:RECTF, srcRect:RECTF, unit:GpUnit, State:DWORD
GdipBeginContainer PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipBeginContainer2  graphics:DWORD, State:DWORD
GdipBeginContainer2 PROTO :DWORD,:DWORD

;GdipBeginContainerI  graphics:DWORD, dstrect:RECTL, srcRect:RECTL, unit:GpUnit, State:DWORD
GdipBeginContainerI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipBitmapGetPixel  bitmap:DWORD, x:DWORD, Y:DWORD, Color:DWORD
GdipBitmapGetPixel PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipBitmapLockBits  bitmap:DWORD, RECT:RECTL, Flags:ImageLockMode, PixelFormat:DWORD, lockedBitmapData:BitmapData
GdipBitmapLockBits PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipBitmapSetPixel  bitmap:DWORD, x:DWORD, Y:DWORD, Color:DWORD
GdipBitmapSetPixel PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipBitmapSetResolution  bitmap:DWORD, xdpi:REAL4, ydpi:REAL4
GdipBitmapSetResolution PROTO :DWORD,:DWORD,:DWORD

;GdipBitmapUnlockBits  bitmap:DWORD, lockedBitmapData:BitmapData
GdipBitmapUnlockBits PROTO :DWORD,:DWORD

;GdipClearPathMarkers  path:DWORD
GdipClearPathMarkers PROTO :DWORD

;GdipCloneBitmapArea  x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4, PixelFormat:DWORD, srcBitmap:DWORD, dstBitmap:DWORD
GdipCloneBitmapArea PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCloneBitmapAreaI  x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD, PixelFormat:DWORD, srcBitmap:DWORD, dstBitmap:DWORD
GdipCloneBitmapAreaI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCloneBrush  brush:DWORD, cloneBrush:DWORD
GdipCloneBrush PROTO :DWORD,:DWORD

;GdipCloneCustomLineCap  customCap:DWORD, clonedCap:DWORD
GdipCloneCustomLineCap PROTO :DWORD,:DWORD

;GdipCloneFont  curFont:DWORD, cloneFont:DWORD
GdipCloneFont PROTO :DWORD,:DWORD

;GdipCloneFontFamily  fontFamily:DWORD, clonedFontFamily:DWORD
GdipCloneFontFamily PROTO :DWORD,:DWORD

;GdipCloneImage  image:DWORD, cloneImage:DWORD
GdipCloneImage PROTO :DWORD,:DWORD

;GdipCloneImageAttributes  imageattr:DWORD, cloneImageattr:DWORD
GdipCloneImageAttributes PROTO :DWORD,:DWORD

;GdipCloneMatrix  matrix:DWORD, cloneMatrix:DWORD
GdipCloneMatrix PROTO :DWORD,:DWORD

;GdipClonePath  path:DWORD, clonePath:DWORD
GdipClonePath PROTO :DWORD,:DWORD

;GdipClonePen  pen:DWORD, clonepen:DWORD
GdipClonePen PROTO :DWORD,:DWORD

;GdipCloneRegion  region:DWORD, cloneRegion:DWORD
GdipCloneRegion PROTO :DWORD,:DWORD

;GdipCloneStringFormat  StringFormat:DWORD, newFormat:DWORD
GdipCloneStringFormat PROTO :DWORD,:DWORD

;GdipClosePathFigure  path:DWORD
GdipClosePathFigure PROTO :DWORD

;GdipClosePathFigures  path:DWORD
GdipClosePathFigures PROTO :DWORD

;GdipCombineRegionPath  region:DWORD, path:DWORD, CombineMd:CombineMode
GdipCombineRegionPath PROTO :DWORD,:DWORD,:DWORD

;GdipCombineRegionRect  region:DWORD, RECT:RECTF, CombineMd:CombineMode
GdipCombineRegionRect PROTO :DWORD,:DWORD,:DWORD

;GdipCombineRegionRectI  region:DWORD, RECT:RECTF, CombineMd:CombineMode
GdipCombineRegionRectI PROTO :DWORD,:DWORD,:DWORD

;GdipCombineRegionRegion  region:DWORD, region2:DWORD, CombineMd:CombineMode
GdipCombineRegionRegion PROTO :DWORD,:DWORD,:DWORD

;GdipComment  graphics:DWORD, sizeData:DWORD, data:Any
GdipComment PROTO :DWORD,:DWORD,:DWORD

;GdipCreateAdjustableArrowCap  Height:REAL4, Width:REAL4, isFilled:DWORD, cap:DWORD
GdipCreateAdjustableArrowCap PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateBitmapFromDirectDrawSurface  surface:DirectDrawSurface7, bitmap:DWORD
GdipCreateBitmapFromDirectDrawSurface PROTO :DWORD,:DWORD

;GdipCreateBitmapFromFile  Filename:DWORD, bitmap:DWORD
GdipCreateBitmapFromFile PROTO :DWORD,:DWORD

;GdipCreateBitmapFromFileICM  Filename:DWORD, bitmap:DWORD
GdipCreateBitmapFromFileICM PROTO :DWORD,:DWORD

;GdipCreateBitmapFromGdiDib  gdiBitmapInfo:BITMAPINFO, gdiBitmapData:DWORD, bitmap:DWORD
GdipCreateBitmapFromGdiDib PROTO :DWORD,:DWORD,:DWORD

;GdipCreateBitmapFromGraphics  Width:DWORD, Height:DWORD, graphics:DWORD, bitmap:DWORD
GdipCreateBitmapFromGraphics PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateBitmapFromHBITMAP  hbm:DWORD, hpal:DWORD, bitmap:DWORD
GdipCreateBitmapFromHBITMAP PROTO :DWORD,:DWORD,:DWORD

;GdipCreateBitmapFromHICON  hicon:DWORD, bitmap:DWORD
GdipCreateBitmapFromHICON PROTO :DWORD,:DWORD

;GdipCreateBitmapFromResource  hInstance:DWORD, lpBitmapName:String, bitmap:DWORD
GdipCreateBitmapFromResource PROTO :DWORD,:DWORD,:DWORD

;GdipCreateBitmapFromScan0  Width:DWORD, Height:DWORD, stride:DWORD, PixelFormat:DWORD, scan0:Any, bitmap:DWORD
GdipCreateBitmapFromScan0 PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateBitmapFromStream  stream:IStream, bitmap:DWORD
GdipCreateBitmapFromStream PROTO :DWORD,:DWORD

;GdipCreateBitmapFromStreamICM  stream:IStream, bitmap:DWORD
GdipCreateBitmapFromStreamICM PROTO :DWORD,:DWORD

;GdipCreateCachedBitmap  bitmap:DWORD, graphics:DWORD, cachedBitmap:DWORD
GdipCreateCachedBitmap PROTO :DWORD,:DWORD,:DWORD

;GdipCreateCustomLineCap  fillPath:DWORD, strokePath:DWORD, baseCap:LineCap, baseInset:REAL4, customCap:DWORD
GdipCreateCustomLineCap PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateFont  fontFamily:DWORD, emSize:REAL4, Style:FontStyle, unit:GpUnit, createdfont:DWORD
GdipCreateFont PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateFontFamilyFromName  name:String, fontCollection:DWORD, fontFamily:DWORD
GdipCreateFontFamilyFromName PROTO :DWORD,:DWORD,:DWORD

;GdipCreateFontFromDC  hdc:DWORD, createdfont:DWORD
GdipCreateFontFromDC PROTO :DWORD,:DWORD

GdipCreateFontFromLogfont equ <GdipCreateFontFromLogfontA>

;GdipCreateFontFromLogfontA  hdc:DWORD, logfont:LOGFONTA, createdfont:DWORD
GdipCreateFontFromLogfontA PROTO :DWORD,:DWORD,:DWORD

;GdipCreateFontFromLogfontW  hdc:DWORD, logfont:LOGFONTW, createdfont:DWORD
GdipCreateFontFromLogfontW PROTO :DWORD,:DWORD,:DWORD


;GdipCreateHalftonePalette  :DWORD
GdipCreateHalftonePalette PROTO 

;GdipCreateHatchBrush  Style:HatchStyle, forecolr:DWORD, backcolr:DWORD, brush:DWORD
GdipCreateHatchBrush PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateHBITMAPFromBitmap  bitmap:DWORD, hbmReturn:DWORD, background:DWORD
GdipCreateHBITMAPFromBitmap PROTO :DWORD,:DWORD,:DWORD

;GdipCreateHICONFromBitmap  bitmap:DWORD, hbmReturn:DWORD
GdipCreateHICONFromBitmap PROTO :DWORD,:DWORD

;GdipCreateLineBrush  point1:POINTF, point2:POINTF, color1:DWORD, color2:DWORD, WrapMd:WrapMode, lineGradient:DWORD
GdipCreateLineBrush PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateLineBrushFromRect  RECT:RECTF, color1:DWORD, color2:DWORD, Mode:LinearGradientMode, WrapMd:WrapMode, lineGradient:DWORD
GdipCreateLineBrushFromRect PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateLineBrushFromRectI  RECT:RECTL, color1:DWORD, color2:DWORD, Mode:LinearGradientMode, WrapMd:WrapMode, lineGradient:DWORD
GdipCreateLineBrushFromRectI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateLineBrushFromRectWithAngle  RECT:RECTF, color1:DWORD, color2:DWORD, angle:REAL4, isAngleScalable:DWORD, WrapMd:WrapMode, lineGradient:DWORD
GdipCreateLineBrushFromRectWithAngle PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateLineBrushFromRectWithAngleI  RECT:RECTL, color1:DWORD, color2:DWORD, angle:REAL4, isAngleScalable:DWORD, WrapMd:WrapMode, lineGradient:DWORD
GdipCreateLineBrushFromRectWithAngleI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateLineBrushI  point1:POINTL, point2:POINTL, color1:DWORD, color2:DWORD, WrapMd:WrapMode, lineGradient:DWORD
GdipCreateLineBrushI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateMatrix  matrix:DWORD
GdipCreateMatrix PROTO :DWORD

;GdipCreateMatrix2  m11:REAL4, m12:REAL4, m21:REAL4, m22:REAL4, dx:REAL4, dy:REAL4, matrix:DWORD
GdipCreateMatrix2 PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateMatrix3  RECT:RECTF, dstplg:POINTF, matrix:DWORD
GdipCreateMatrix3 PROTO :DWORD,:DWORD,:DWORD

;GdipCreateMatrix3I  RECT:RECTL, dstplg:POINTL, matrix:DWORD
GdipCreateMatrix3I PROTO :DWORD,:DWORD,:DWORD

;GdipCreateMetafileFromEmf  hEmf:DWORD, bDeleteEmf:DWORD, metafile:DWORD
GdipCreateMetafileFromEmf PROTO :DWORD,:DWORD,:DWORD

;GdipCreateMetafileFromFile  byvalfile:String, metafile:DWORD
GdipCreateMetafileFromFile PROTO :DWORD,:DWORD

;GdipCreateMetafileFromStream  stream:IStream, metafile:DWORD
GdipCreateMetafileFromStream PROTO :DWORD,:DWORD

;GdipCreateMetafileFromWmf  hWmf:DWORD, bDeleteWmf:DWORD, WmfPlaceableFileHdr:WmfPlaceableFileHeader, metafile:DWORD
GdipCreateMetafileFromWmf PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateMetafileFromWmfFile  file:String, WmfPlaceableFileHdr:WmfPlaceableFileHeader, metafile:DWORD
GdipCreateMetafileFromWmfFile PROTO :DWORD,:DWORD,:DWORD

;GdipCreatePath  brushmode:FillMode, path:DWORD
GdipCreatePath PROTO :DWORD,:DWORD

;GdipCreatePath2  Points:POINTF, types:Any, count:DWORD, brushmode:FillMode, path:DWORD
GdipCreatePath2 PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreatePath2I  Points:POINTL, types:Any, count:DWORD, brushmode:FillMode, path:DWORD
GdipCreatePath2I PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreatePathGradient  Points:POINTF, count:DWORD, WrapMd:WrapMode, polyGradient:DWORD
GdipCreatePathGradient PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipCreatePathGradientFromPath  path:DWORD, polyGradient:DWORD
GdipCreatePathGradientFromPath PROTO :DWORD,:DWORD

;GdipCreatePathGradientI  Points:POINTL, count:DWORD, WrapMd:WrapMode, polyGradient:DWORD
GdipCreatePathGradientI PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipCreatePathIter  iterator:DWORD, path:DWORD
GdipCreatePathIter PROTO :DWORD,:DWORD

;GdipCreatePen1  Color:DWORD, Width:REAL4, unit:GpUnit, pen:DWORD
GdipCreatePen1 PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipCreatePen2  brush:DWORD, Width:REAL4, unit:GpUnit, pen:DWORD
GdipCreatePen2 PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateRegion  region:DWORD
GdipCreateRegion PROTO :DWORD

;GdipCreateRegionHrgn  hRgn:DWORD, region:DWORD
GdipCreateRegionHrgn PROTO :DWORD,:DWORD

;GdipCreateRegionPath  path:DWORD, region:DWORD
GdipCreateRegionPath PROTO :DWORD,:DWORD

;GdipCreateRegionRect  RECT:RECTF, region:DWORD
GdipCreateRegionRect PROTO :DWORD,:DWORD

;GdipCreateRegionRectI  RECT:RECTL, region:DWORD
GdipCreateRegionRectI PROTO :DWORD,:DWORD

;GdipCreateRegionRgnData  regionData:Any, SIZE:DWORD, region:DWORD
GdipCreateRegionRgnData PROTO :DWORD,:DWORD,:DWORD

;GdipCreateSolidFill  argb:DWORD, brush:DWORD
GdipCreateSolidFill PROTO :DWORD,:DWORD

;GdipCreateStreamOnFile  filename:String, access:DWORD, stream:IStream
GdipCreateStreamOnFile PROTO :DWORD,:DWORD,:DWORD

;GdipCreateStringFormat  formatAttributes:DWORD, language:Integer, StringFormat:DWORD
GdipCreateStringFormat PROTO :DWORD,:DWORD,:DWORD

;GdipCreateTexture  image:DWORD, WrapMd:WrapMode, texture:DWORD
GdipCreateTexture PROTO :DWORD,:DWORD,:DWORD

;GdipCreateTexture2  image:DWORD, WrapMd:WrapMode, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4, texture:DWORD
GdipCreateTexture2 PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateTexture2I  image:DWORD, WrapMd:WrapMode, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD, texture:DWORD
GdipCreateTexture2I PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateTextureI equ <GdipCreateTextureIA>

;GdipCreateTextureIA  image:DWORD, imageAttributes:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4, texture:DWORD
GdipCreateTextureIA PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipCreateTextureIAI  image:DWORD, imageAttributes:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD, texture:DWORD
GdipCreateTextureIAI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDeleteBrush  brush:DWORD
GdipDeleteBrush PROTO :DWORD

;GdipDeleteCachedBitmap  cachedBitmap:DWORD
GdipDeleteCachedBitmap PROTO :DWORD

;GdipDeleteCustomLineCap  customCap:DWORD
GdipDeleteCustomLineCap PROTO :DWORD

;GdipDeleteFont  curFont:DWORD
GdipDeleteFont PROTO :DWORD

;GdipDeleteFontFamily  fontFamily:DWORD
GdipDeleteFontFamily PROTO :DWORD

;GdipDeleteGraphics  graphics:DWORD
GdipDeleteGraphics PROTO :DWORD

;GdipDeleteMatrix  matrix:DWORD
GdipDeleteMatrix PROTO :DWORD

;GdipDeletePath  path:DWORD
GdipDeletePath PROTO :DWORD

;GdipDeletePathIter  iterator:DWORD
GdipDeletePathIter PROTO :DWORD

;GdipDeletePen  pen:DWORD
GdipDeletePen PROTO :DWORD

;GdipDeletePrivateFontCollection  fontCollection:DWORD
GdipDeletePrivateFontCollection PROTO :DWORD

;GdipDeleteRegion  region:DWORD
GdipDeleteRegion PROTO :DWORD

;GdipDeleteStringFormat  StringFormat:DWORD
GdipDeleteStringFormat PROTO :DWORD

;GdipDisposeImage  image:DWORD
GdipDisposeImage PROTO :DWORD

;GdipDisposeImageAttributes  imageattr:DWORD
GdipDisposeImageAttributes PROTO :DWORD

;GdipDrawArc  graphics:DWORD, pen:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4, startAngle:REAL4, sweepAngle:REAL4
GdipDrawArc PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawArcI  graphics:DWORD, pen:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD, startAngle:REAL4, sweepAngle:REAL4
GdipDrawArcI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawBezier  graphics:DWORD, pen:DWORD, X1:REAL4, Y1:REAL4, X2:REAL4, Y2:REAL4, X3:REAL4, Y3:REAL4, x4:REAL4, y4:REAL4
GdipDrawBezier PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawBezierI  graphics:DWORD, pen:DWORD, X1:DWORD, Y1:DWORD, X2:DWORD, Y2:DWORD, X3:DWORD, Y3:DWORD, x4:DWORD, y4:DWORD
GdipDrawBezierI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawBeziers  graphics:DWORD, pen:DWORD, Points:POINTF, count:DWORD
GdipDrawBeziers PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawBeziersI  graphics:DWORD, pen:DWORD, Points:POINTL, count:DWORD
GdipDrawBeziersI PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawCachedBitmap  graphics:DWORD, cachedBitmap:DWORD, x:DWORD, Y:DWORD
GdipDrawCachedBitmap PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawClosedCurve  graphics:DWORD, pen:DWORD, Points:POINTF, count:DWORD
GdipDrawClosedCurve PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawClosedCurve2  graphics:DWORD, pen:DWORD, Points:POINTF, count:DWORD, tension:REAL4
GdipDrawClosedCurve2 PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawClosedCurve2I  graphics:DWORD, pen:DWORD, Points:POINTL, count:DWORD, tension:REAL4
GdipDrawClosedCurve2I PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawClosedCurveI  graphics:DWORD, pen:DWORD, Points:POINTL, count:DWORD
GdipDrawClosedCurveI PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawCurve  graphics:DWORD, pen:DWORD, Points:POINTF, count:DWORD
GdipDrawCurve PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawCurve2  graphics:DWORD, pen:DWORD, Points:POINTF, count:DWORD, tension:REAL4
GdipDrawCurve2 PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawCurve2I  graphics:DWORD, pen:DWORD, Points:POINTL, count:DWORD, tension:REAL4
GdipDrawCurve2I PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawCurve3  graphics:DWORD, pen:DWORD, Points:POINTF, count:DWORD, Offset:DWORD, numberOfSegments:DWORD, tension:REAL4
GdipDrawCurve3 PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawCurve3I  graphics:DWORD, pen:DWORD, Points:POINTL, count:DWORD, Offset:DWORD, numberOfSegments:DWORD, tension:REAL4
GdipDrawCurve3I PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawCurveI  graphics:DWORD, pen:DWORD, Points:POINTL, count:DWORD
GdipDrawCurveI PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawDriverString  graphics:DWORD, str:String, Length:DWORD, thefont:DWORD, brush:DWORD, positions:POINTF, Flags:DWORD, matrix:DWORD
GdipDrawDriverString PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawEllipse  graphics:DWORD, pen:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4
GdipDrawEllipse PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawEllipseI  graphics:DWORD, pen:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD
GdipDrawEllipseI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD



;GdipDrawLine  graphics:DWORD, pen:DWORD, X1:REAL4, Y1:REAL4, X2:REAL4, Y2:REAL4
GdipDrawLine PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawLineI  graphics:DWORD, pen:DWORD, X1:DWORD, Y1:DWORD, X2:DWORD, Y2:DWORD
GdipDrawLineI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawLines  graphics:DWORD, pen:DWORD, Points:POINTF, count:DWORD
GdipDrawLines PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawLinesI  graphics:DWORD, pen:DWORD, Points:POINTL, count:DWORD
GdipDrawLinesI PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawPath  graphics:DWORD, pen:DWORD, path:DWORD
GdipDrawPath PROTO :DWORD,:DWORD,:DWORD

;GdipDrawPie  graphics:DWORD, pen:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4, startAngle:REAL4, sweepAngle:REAL4
GdipDrawPie PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawPieI  graphics:DWORD, pen:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD, startAngle:REAL4, sweepAngle:REAL4
GdipDrawPieI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawPolygon  graphics:DWORD, pen:DWORD, Points:POINTF, count:DWORD
GdipDrawPolygon PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawPolygonI  graphics:DWORD, pen:DWORD, Points:POINTL, count:DWORD
GdipDrawPolygonI PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawRectangle  graphics:DWORD, pen:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4
GdipDrawRectangle PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawRectangleI  graphics:DWORD, pen:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD
GdipDrawRectangleI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawRectangles  graphics:DWORD, pen:DWORD, rects:RECTF, count:DWORD
GdipDrawRectangles PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawRectanglesI  graphics:DWORD, pen:DWORD, rects:RECTL, count:DWORD
GdipDrawRectanglesI PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipDrawString  graphics:DWORD, str:String, Length:DWORD, thefont:DWORD, layoutRect:RECTF, StringFormat:DWORD, brush:DWORD
GdipDrawString PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

GdipEmfToWmfBits PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipEndContainer  graphics:DWORD, State:DWORD
GdipEndContainer PROTO :DWORD,:DWORD

;GdipEnumerateMetafileDestPoint  graphics:DWORD, metafile:DWORD, destPoint:POINTF, lpEnumerateMetafileProc:DWORD, callbackData:DWORD, imageAttributes:DWORD
GdipEnumerateMetafileDestPoint PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipEnumerateMetafileDestPointI  graphics:DWORD, metafile:DWORD, destPoint:POINTL, lpEnumerateMetafileProc:DWORD, callbackData:DWORD, imageAttributes:DWORD
GdipEnumerateMetafileDestPointI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipEnumerateMetafileDestPoints  graphics:DWORD, metafile:DWORD, destPoint:POINTF, count:DWORD, lpEnumerateMetafileProc:DWORD, callbackData:DWORD, imageAttributes:DWORD
GdipEnumerateMetafileDestPoints PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipEnumerateMetafileDestPointsI  graphics:DWORD, metafile:DWORD, destPoint:POINTL, count:DWORD, lpEnumerateMetafileProc:DWORD, callbackData:DWORD, imageAttributes:DWORD
GdipEnumerateMetafileDestPointsI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipEnumerateMetafileDestRect  graphics:DWORD, metafile:DWORD, destRect:RECTF, lpEnumerateMetafileProc:DWORD, callbackData:DWORD, imageAttributes:DWORD
GdipEnumerateMetafileDestRect PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipEnumerateMetafileDestRectI  graphics:DWORD, metafile:DWORD, destRect:RECTL, lpEnumerateMetafileProc:DWORD, callbackData:DWORD, imageAttributes:DWORD
GdipEnumerateMetafileDestRectI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipEnumerateMetafileSrcRectDestPoint  graphics:DWORD, metafile:DWORD, destPoint:POINTF, srcRect:RECTF, srcUnit:GpUnit, lpEnumerateMetafileProc:DWORD, callbackData:DWORD, imageAttributes:DWORD
GdipEnumerateMetafileSrcRectDestPoint PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipEnumerateMetafileSrcRectDestPointI  graphics:DWORD, metafile:DWORD, destPoint:POINTL, srcRect:RECTL, srcUnit:GpUnit, lpEnumerateMetafileProc:DWORD, callbackData:DWORD, imageAttributes:DWORD
GdipEnumerateMetafileSrcRectDestPointI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipEnumerateMetafileSrcRectDestPoints  graphics:DWORD, metafile:DWORD, destPoints:POINTF, count:DWORD, srcRect:RECTF, srcUnit:GpUnit, lpEnumerateMetafileProc:DWORD, callbackData:DWORD, imageAttributes:DWORD
GdipEnumerateMetafileSrcRectDestPoints PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipEnumerateMetafileSrcRectDestPointsI  graphics:DWORD, metafile:DWORD, destPoints:POINTL, count:DWORD, srcRect:RECTL, srcUnit:GpUnit, lpEnumerateMetafileProc:DWORD, callbackData:DWORD, imageAttributes:DWORD
GdipEnumerateMetafileSrcRectDestPointsI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipEnumerateMetafileSrcRectDestRect  graphics:DWORD, metafile:DWORD, destRect:RECTF, srcRect:RECTF, srcUnit:GpUnit, lpEnumerateMetafileProc:DWORD, callbackData:DWORD, imageAttributes:DWORD
GdipEnumerateMetafileSrcRectDestRect PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipEnumerateMetafileSrcRectDestRectI  graphics:DWORD, metafile:DWORD, destRect:RECTL, srcRect:RECTL, srcUnit:GpUnit, lpEnumerateMetafileProc:DWORD, callbackData:DWORD, imageAttributes:DWORD
GdipEnumerateMetafileSrcRectDestRectI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipFillClosedCurve  graphics:DWORD, brush:DWORD, Points:POINTF, count:DWORD
GdipFillClosedCurve PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipFillClosedCurve2  graphics:DWORD, brush:DWORD, Points:POINTF, count:DWORD, tension:REAL4, FillMd:FillMode
GdipFillClosedCurve2 PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipFillClosedCurve2I  graphics:DWORD, brush:DWORD, Points:POINTL, count:DWORD, tension:REAL4, FillMd:FillMode
GdipFillClosedCurve2I PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipFillClosedCurveI  graphics:DWORD, brush:DWORD, Points:POINTL, count:DWORD
GdipFillClosedCurveI PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipFillEllipse  graphics:DWORD, brush:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4
GdipFillEllipse PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipFillEllipseI  graphics:DWORD, brush:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD
GdipFillEllipseI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipFillPath  graphics:DWORD, brush:DWORD, path:DWORD
GdipFillPath PROTO :DWORD,:DWORD,:DWORD

;GdipFillPie  graphics:DWORD, brush:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4, startAngle:REAL4, sweepAngle:REAL4
GdipFillPie PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipFillPieI  graphics:DWORD, brush:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD, startAngle:REAL4, sweepAngle:REAL4
GdipFillPieI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipFillPolygon  graphics:DWORD, brush:DWORD, Points:POINTF, count:DWORD, FillMd:FillMode
GdipFillPolygon PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipFillPolygon2  graphics:DWORD, brush:DWORD, Points:POINTF, count:DWORD
GdipFillPolygon2 PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipFillPolygon2I  graphics:DWORD, brush:DWORD, Points:POINTL, count:DWORD
GdipFillPolygon2I PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipFillPolygonI  graphics:DWORD, brush:DWORD, Points:POINTL, count:DWORD, FillMd:FillMode
GdipFillPolygonI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipFillRectangle  graphics:DWORD, brush:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4
GdipFillRectangle PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipFillRectangleI  graphics:DWORD, brush:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD
GdipFillRectangleI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipFillRectangles  graphics:DWORD, brush:DWORD, rects:RECTF, count:DWORD
GdipFillRectangles PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipFillRectanglesI  graphics:DWORD, brush:DWORD, rects:RECTL, count:DWORD
GdipFillRectanglesI PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipFillRegion  graphics:DWORD, brush:DWORD, region:DWORD
GdipFillRegion PROTO :DWORD,:DWORD,:DWORD

;GdipFlattenPath  path:DWORD, Optional matrix:DWORD = 0, Optional flatness:REAL4 = FlatnessDefault
GdipFlattenPath PROTO :DWORD,:DWORD,:DWORD

;GdipFlush  graphics:DWORD, intention:FlushIntention
GdipFlush PROTO :DWORD,:DWORD

;GdipFontCollectionEnumerable  fontCollection:DWORD, graphics:DWORD, numFound:DWORD

;GdipFontCollectionEnumerate  fontCollection:DWORD, numSought:DWORD, gpfamilies:DWORD, numFound:DWORD, graphics:DWORD

;GdipFree  ptr:DWORD
GdipFree PROTO :DWORD

;GdipGetAdjustableArrowCapFillState  cap:DWORD, bFillState:DWORD
GdipGetAdjustableArrowCapFillState PROTO :DWORD,:DWORD

;GdipGetAdjustableArrowCapHeight  cap:DWORD, Height:REAL4
GdipGetAdjustableArrowCapHeight PROTO :DWORD,:DWORD

;GdipGetAdjustableArrowCapMiddleInset  cap:DWORD, middleInset:REAL4
GdipGetAdjustableArrowCapMiddleInset PROTO :DWORD,:DWORD

;GdipGetAdjustableArrowCapWidth  cap:DWORD, Width:REAL4
GdipGetAdjustableArrowCapWidth PROTO :DWORD,:DWORD



;GdipGetBrushType  brush:DWORD, brshType:BrushType
GdipGetBrushType PROTO :DWORD,:DWORD

;GdipGetCellAscent  family:DWORD, Style:DWORD, CellAscent:Integer
GdipGetCellAscent PROTO :DWORD,:DWORD,:DWORD

;GdipGetCellDescent  family:DWORD, Style:DWORD, CellDescent:Integer
GdipGetCellDescent PROTO :DWORD,:DWORD,:DWORD

;GdipGetClip  graphics:DWORD, region:DWORD
GdipGetClip PROTO :DWORD,:DWORD

;GdipGetClipBounds  graphics:DWORD, RECT:RECTF
GdipGetClipBounds PROTO :DWORD,:DWORD

;GdipGetClipBoundsI  graphics:DWORD, RECT:RECTL
GdipGetClipBoundsI PROTO :DWORD,:DWORD

;GdipGetCompositingMode  graphics:DWORD, CompositingMd:CompositingMode
GdipGetCompositingMode PROTO :DWORD,:DWORD

;GdipGetCompositingQuality  graphics:DWORD, CompositingQlty:CompositingQuality
GdipGetCompositingQuality PROTO :DWORD,:DWORD

;GdipGetCustomLineCapBaseCap  customCap:DWORD, baseCap:LineCap
GdipGetCustomLineCapBaseCap PROTO :DWORD,:DWORD

;GdipGetCustomLineCapBaseInset  customCap:DWORD, inset:REAL4
GdipGetCustomLineCapBaseInset PROTO :DWORD,:DWORD

;GdipGetCustomLineCapStrokeCaps  customCap:DWORD, startCap:LineCap, endCap:LineCap
GdipGetCustomLineCapStrokeCaps PROTO :DWORD,:DWORD,:DWORD

;GdipGetCustomLineCapStrokeJoin  customCap:DWORD, LnJoin:LineJoin
GdipGetCustomLineCapStrokeJoin PROTO :DWORD,:DWORD

;GdipGetCustomLineCapType  customCap:DWORD, capType:CustomLineCapType
GdipGetCustomLineCapType PROTO :DWORD,:DWORD

;GdipGetCustomLineCapWidthScale  customCap:DWORD, widthScale:REAL4
GdipGetCustomLineCapWidthScale PROTO :DWORD,:DWORD

;GdipGetDC  graphics:DWORD, hdc:DWORD
GdipGetDC PROTO :DWORD,:DWORD

;GdipGetDpiX  graphics:DWORD, dpi:REAL4
GdipGetDpiX PROTO :DWORD,:DWORD

;GdipGetDpiY  graphics:DWORD, dpi:REAL4
GdipGetDpiY PROTO :DWORD,:DWORD

;GdipGetEmHeight  family:DWORD, Style:DWORD, EmHeight:Integer
GdipGetEmHeight PROTO :DWORD,:DWORD,:DWORD

;GdipGetEncoderParameterList  image:DWORD, clsidEncoder:CLSID, SIZE:DWORD, buffer:EncoderParameters
GdipGetEncoderParameterList PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipGetEncoderParameterListSize  image:DWORD, clsidEncoder:CLSID, SIZE:DWORD
GdipGetEncoderParameterListSize PROTO :DWORD,:DWORD,:DWORD

;GdipGetFamily  curFont:DWORD, family:DWORD
GdipGetFamily PROTO :DWORD,:DWORD

;GdipGetFamilyName  family:DWORD, name:String, language:Integer
GdipGetFamilyName PROTO :DWORD,:DWORD,:DWORD

;GdipGetFontCollectionFamilyCount  fontCollection:DWORD, numFound:DWORD
GdipGetFontCollectionFamilyCount PROTO :DWORD,:DWORD

;GdipGetFontCollectionFamilyList  fontCollection:DWORD, numSought:DWORD, gpfamilies:DWORD, numFound:DWORD
GdipGetFontCollectionFamilyList PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipGetFontHeight  curFont:DWORD, graphics:DWORD, Height:REAL4
GdipGetFontHeight PROTO :DWORD,:DWORD,:DWORD

;GdipGetFontHeightGivenDPI  curFont:DWORD, dpi:REAL4, Height:REAL4
GdipGetFontHeightGivenDPI PROTO :DWORD,:DWORD,:DWORD

;GdipGetFontSize  curFont:DWORD, SIZE:REAL4
GdipGetFontSize PROTO :DWORD,:DWORD

;GdipGetFontStyle  curFont:DWORD, Style:DWORD
GdipGetFontStyle PROTO :DWORD,:DWORD

;GdipGetFontUnit  curFont:DWORD, unit:GpUnit
GdipGetFontUnit PROTO :DWORD,:DWORD

;GdipGetGenericFontFamilyMonospace  nativeFamily:DWORD
GdipGetGenericFontFamilyMonospace PROTO :DWORD

;GdipGetGenericFontFamilySansSerif  nativeFamily:DWORD
GdipGetGenericFontFamilySansSerif PROTO :DWORD

;GdipGetGenericFontFamilySerif  nativeFamily:DWORD
GdipGetGenericFontFamilySerif PROTO :DWORD

GdipGetGraphicsLayout PROTO :DWORD,:DWORD

;GdipGetHatchBackgroundColor  brush:DWORD, backcolr:DWORD
GdipGetHatchBackgroundColor PROTO :DWORD,:DWORD

;GdipGetHatchForegroundColor  brush:DWORD, forecolr:DWORD
GdipGetHatchForegroundColor PROTO :DWORD,:DWORD

;GdipGetHatchStyle  brush:DWORD, Style:HatchStyle
GdipGetHatchStyle PROTO :DWORD,:DWORD

;GdipGetHemfFromMetafile  metafile:DWORD, hEmf:DWORD
GdipGetHemfFromMetafile PROTO :DWORD,:DWORD













;GdipGetInterpolationMode  graphics:DWORD, interpolation:InterpolationMode
GdipGetInterpolationMode PROTO :DWORD,:DWORD

;GdipGetLineBlend  brush:DWORD, blend:REAL4, positions:REAL4, count:DWORD
GdipGetLineBlend PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipGetLineBlendCount  brush:DWORD, count:DWORD
GdipGetLineBlendCount PROTO :DWORD,:DWORD

;GdipGetLineColors  brush:DWORD, lColors:DWORD
GdipGetLineColors PROTO :DWORD,:DWORD

;GdipGetLineGammaCorrection  brush:DWORD, useGammaCorrection:DWORD
GdipGetLineGammaCorrection PROTO :DWORD,:DWORD

GdipGetLinePoints PROTO :DWORD,:DWORD

GdipGetLinePointsI PROTO :DWORD,:DWORD

;GdipGetLinePresetBlend  brush:DWORD, blend:DWORD, positions:REAL4, count:DWORD
GdipGetLinePresetBlend PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipGetLinePresetBlendCount  brush:DWORD, count:DWORD
GdipGetLinePresetBlendCount PROTO :DWORD,:DWORD

;GdipGetLineRect  brush:DWORD, RECT:RECTF
GdipGetLineRect PROTO :DWORD,:DWORD

;GdipGetLineRectI  brush:DWORD, RECT:RECTL
GdipGetLineRectI PROTO :DWORD,:DWORD

;GdipGetLineSpacing  family:DWORD, Style:DWORD, LineSpacing:Integer
GdipGetLineSpacing PROTO :DWORD,:DWORD,:DWORD

;GdipGetLineTransform  brush:DWORD, matrix:DWORD
GdipGetLineTransform PROTO :DWORD,:DWORD

;GdipGetLineWrapMode  brush:DWORD, WrapMd:WrapMode
GdipGetLineWrapMode PROTO :DWORD,:DWORD

GdipGetLogFont equ <GdipGetLogFontA>

;GdipGetLogFontA  curFont:DWORD, graphics:DWORD, logfont:LOGFONTA
GdipGetLogFontA PROTO :DWORD,:DWORD,:DWORD

;GdipGetLogFontW  curFont:DWORD, graphics:DWORD, logfont:LOGFONTW
GdipGetLogFontW PROTO :DWORD,:DWORD,:DWORD

;GdipGetMatrixElements  matrix:DWORD, matrixOut:REAL4
GdipGetMatrixElements PROTO :DWORD,:DWORD

;GdipGetMetafileDownLevelRasterizationLimit  metafile:DWORD, metafileRasterizationLimitDpi:DWORD
GdipGetMetafileDownLevelRasterizationLimit PROTO :DWORD,:DWORD

;GdipGetMetafileHeaderFromEmf  hEmf:DWORD, header:MetafileHeader
GdipGetMetafileHeaderFromEmf PROTO :DWORD,:DWORD

;GdipGetMetafileHeaderFromFile  Filename:String, header:MetafileHeader
GdipGetMetafileHeaderFromFile PROTO :DWORD,:DWORD

;GdipGetMetafileHeaderFromMetafile  metafile:DWORD, header:MetafileHeader
GdipGetMetafileHeaderFromMetafile PROTO :DWORD,:DWORD

;GdipGetMetafileHeaderFromStream  stream:IStream, header:MetafileHeader
GdipGetMetafileHeaderFromStream PROTO :DWORD,:DWORD

;GdipGetMetafileHeaderFromWmf  hWmf:DWORD, WmfPlaceableFileHdr:WmfPlaceableFileHeader, header:MetafileHeader
GdipGetMetafileHeaderFromWmf PROTO :DWORD,:DWORD,:DWORD

;GdipGetNearestColor  graphics:DWORD, argb:DWORD
GdipGetNearestColor PROTO :DWORD,:DWORD

;GdipGetPageScale  graphics:DWORD, sscale:REAL4
GdipGetPageScale PROTO :DWORD,:DWORD

;GdipGetPageUnit  graphics:DWORD, unit:GpUnit
GdipGetPageUnit PROTO :DWORD,:DWORD

;GdipGetPathData  path:DWORD, pdata:PathData
GdipGetPathData PROTO :DWORD,:DWORD

;GdipGetPathFillMode  path:DWORD, brushmode:FillMode
GdipGetPathFillMode PROTO :DWORD,:DWORD

;GdipGetPathGradientBlend  brush:DWORD, blend:REAL4, positions:REAL4, count:DWORD
GdipGetPathGradientBlend PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipGetPathGradientBlendCount  brush:DWORD, count:DWORD
GdipGetPathGradientBlendCount PROTO :DWORD,:DWORD

;GdipGetPathGradientCenterColor  brush:DWORD, lColors:DWORD
GdipGetPathGradientCenterColor PROTO :DWORD,:DWORD

;GdipGetPathGradientCenterPoint  brush:DWORD, Points:POINTF
GdipGetPathGradientCenterPoint PROTO :DWORD,:DWORD

;GdipGetPathGradientCenterPointI  brush:DWORD, Points:POINTL
GdipGetPathGradientCenterPointI PROTO :DWORD,:DWORD

;GdipGetPathGradientFocusScales  brush:DWORD, xScale:REAL4, yScale:REAL4
GdipGetPathGradientFocusScales PROTO :DWORD,:DWORD,:DWORD

;GdipGetPathGradientGammaCorrection  brush:DWORD, useGammaCorrection:DWORD
GdipGetPathGradientGammaCorrection PROTO :DWORD,:DWORD

;GdipGetPathGradientPath  brush:DWORD, path:DWORD
GdipGetPathGradientPath PROTO :DWORD,:DWORD

;GdipGetPathGradientPointCount  brush:DWORD, count:DWORD
GdipGetPathGradientPointCount PROTO :DWORD,:DWORD

;GdipGetPathGradientPresetBlend  brush:DWORD, blend:DWORD, positions:REAL4, count:DWORD
GdipGetPathGradientPresetBlend PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipGetPathGradientPresetBlendCount  brush:DWORD, count:DWORD
GdipGetPathGradientPresetBlendCount PROTO :DWORD,:DWORD

;GdipGetPathGradientRect  brush:DWORD, RECT:RECTF
GdipGetPathGradientRect PROTO :DWORD,:DWORD

;GdipGetPathGradientRectI  brush:DWORD, RECT:RECTL
GdipGetPathGradientRectI PROTO :DWORD,:DWORD

;GdipGetPathGradientSurroundColorCount  brush:DWORD, count:DWORD
GdipGetPathGradientSurroundColorCount PROTO :DWORD,:DWORD

;GdipGetPathGradientSurroundColorsWithCount  brush:DWORD, argb:DWORD, count:DWORD
GdipGetPathGradientSurroundColorsWithCount PROTO :DWORD,:DWORD,:DWORD

;GdipGetPathGradientTransform  brush:DWORD, matrix:DWORD
GdipGetPathGradientTransform PROTO :DWORD,:DWORD

;GdipGetPathGradientWrapMode  brush:DWORD, WrapMd:WrapMode
GdipGetPathGradientWrapMode PROTO :DWORD,:DWORD

;GdipGetPathLastPoint  path:DWORD, lastPoint:POINTF
GdipGetPathLastPoint PROTO :DWORD,:DWORD

;GdipGetPathPoints  path:DWORD, Points:POINTF, count:DWORD
GdipGetPathPoints PROTO :DWORD,:DWORD,:DWORD

;GdipGetPathPointsI  path:DWORD, Points:POINTL, count:DWORD
GdipGetPathPointsI PROTO :DWORD,:DWORD,:DWORD

;GdipGetPathTypes  path:DWORD, types:Any, count:DWORD
GdipGetPathTypes PROTO :DWORD,:DWORD,:DWORD

;GdipGetPathWorldBounds  path:DWORD, bounds:RECTF, matrix:DWORD, pen:DWORD
GdipGetPathWorldBounds PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipGetPathWorldBoundsI  path:DWORD, bounds:RECTL, matrix:DWORD, pen:DWORD
GdipGetPathWorldBoundsI PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipGetPenBrushFill  pen:DWORD, brush:DWORD
GdipGetPenBrushFill PROTO :DWORD,:DWORD

;GdipGetPenColor  pen:DWORD, argb:DWORD
GdipGetPenColor PROTO :DWORD,:DWORD

;GdipGetPenCompoundArray  pen:DWORD, dash:REAL4, count:DWORD
GdipGetPenCompoundArray PROTO :DWORD,:DWORD,:DWORD

;GdipGetPenCompoundCount  pen:DWORD, count:DWORD
GdipGetPenCompoundCount PROTO :DWORD,:DWORD

;GdipGetPenCustomEndCap  pen:DWORD, customCap:DWORD
GdipGetPenCustomEndCap PROTO :DWORD,:DWORD

;GdipGetPenCustomStartCap  pen:DWORD, customCap:DWORD
GdipGetPenCustomStartCap PROTO :DWORD,:DWORD

;GdipGetPenDashArray  pen:DWORD, dash:REAL4, count:DWORD
GdipGetPenDashArray PROTO :DWORD,:DWORD,:DWORD

;GdipGetPenDashCap  pen:DWORD, dcap:DashCap
GdipGetPenDashCap197819 PROTO :DWORD,:DWORD

;GdipGetPenDashCount  pen:DWORD, count:DWORD
GdipGetPenDashCount PROTO :DWORD,:DWORD

;GdipGetPenDashOffset  pen:DWORD, Offset:REAL4
GdipGetPenDashOffset PROTO :DWORD,:DWORD

;GdipGetPenDashStyle  pen:DWORD, dStyle:DashStyle
GdipGetPenDashStyle PROTO :DWORD,:DWORD

;GdipGetPenEndCap  pen:DWORD, endCap:LineCap
GdipGetPenEndCap PROTO :DWORD,:DWORD

;GdipGetPenFillType  pen:DWORD, ptype:PenType
GdipGetPenFillType PROTO :DWORD,:DWORD

;GdipGetPenLineJoin  pen:DWORD, LnJoin:LineJoin
GdipGetPenLineJoin PROTO :DWORD,:DWORD

;GdipGetPenMiterLimit  pen:DWORD, miterLimit:REAL4
GdipGetPenMiterLimit PROTO :DWORD,:DWORD

;GdipGetPenMode  pen:DWORD, penMode:PenAlignment
GdipGetPenMode PROTO :DWORD,:DWORD

;GdipGetPenStartCap  pen:DWORD, startCap:LineCap
GdipGetPenStartCap PROTO :DWORD,:DWORD

;GdipGetPenTransform  pen:DWORD, matrix:DWORD
GdipGetPenTransform PROTO :DWORD,:DWORD

;GdipGetPenUnit  pen:DWORD, unit:GpUnit
GdipGetPenUnit PROTO :DWORD,:DWORD

;GdipGetPenWidth  pen:DWORD, Width:REAL4
GdipGetPenWidth PROTO :DWORD,:DWORD

;GdipGetPixelOffsetMode  graphics:DWORD, PixOffsetMode:PixelOffsetMode
GdipGetPixelOffsetMode PROTO :DWORD,:DWORD

;GdipGetPointCount  path:DWORD, count:DWORD
GdipGetPointCount PROTO :DWORD,:DWORD



;GdipGetRegionBounds  region:DWORD, graphics:DWORD, RECT:RECTF
GdipGetRegionBounds PROTO :DWORD,:DWORD,:DWORD

;GdipGetRegionBoundsI  region:DWORD, graphics:DWORD, RECT:RECTL
GdipGetRegionBoundsI PROTO :DWORD,:DWORD,:DWORD

;GdipGetRegionData  region:DWORD, buffer:Any, bufferSize:DWORD, sizeFilled:DWORD
GdipGetRegionData PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipGetRegionDataSize  region:DWORD, bufferSize:DWORD
GdipGetRegionDataSize PROTO :DWORD,:DWORD

;GdipGetRegionHRgn  region:DWORD, graphics:DWORD, hRgn:DWORD
GdipGetRegionHRgn PROTO :DWORD,:DWORD,:DWORD

;GdipGetRegionScans  region:DWORD, rects:RECTF, count:DWORD, matrix:DWORD
GdipGetRegionScans PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipGetRegionScansCount  region:DWORD, Ucount:DWORD, matrix:DWORD
GdipGetRegionScansCount PROTO :DWORD,:DWORD,:DWORD

;GdipGetRegionScansI  region:DWORD, rects:RECTL, count:DWORD, matrix:DWORD
GdipGetRegionScansI PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipGetRenderingOrigin  graphics:DWORD, x:DWORD, Y:DWORD
GdipGetRenderingOrigin PROTO :DWORD,:DWORD,:DWORD

;GdipGetSmoothingMode  graphics:DWORD, SmoothingMd:SmoothingMode
GdipGetSmoothingMode PROTO :DWORD,:DWORD

;GdipGetSolidFillColor  brush:DWORD, argb:DWORD
GdipGetSolidFillColor PROTO :DWORD,:DWORD

;GdipGetStringFormatAlign  StringFormat:DWORD, align:StringAlignment
GdipGetStringFormatAlign PROTO :DWORD,:DWORD

;GdipGetStringFormatDigitSubstitution  StringFormat:DWORD, language:Integer, substitute:StringDigitSubstitute
GdipGetStringFormatDigitSubstitution PROTO :DWORD,:DWORD,:DWORD

;GdipGetStringFormatFlags  StringFormat:DWORD, Flags:DWORD
GdipGetStringFormatFlags PROTO :DWORD,:DWORD

;GdipGetStringFormatHotkeyPrefix  StringFormat:DWORD, hkPrefix:HotkeyPrefix
GdipGetStringFormatHotkeyPrefix PROTO :DWORD,:DWORD

;GdipGetStringFormatLineAlign  StringFormat:DWORD, align:StringAlignment
GdipGetStringFormatLineAlign PROTO :DWORD,:DWORD

;GdipGetStringFormatMeasurableCharacterRangeCount  StringFormat:DWORD, count:DWORD
GdipGetStringFormatMeasurableCharacterRangeCount PROTO :DWORD,:DWORD

;GdipGetStringFormatTabStopCount  StringFormat:DWORD, count:DWORD
GdipGetStringFormatTabStopCount PROTO :DWORD,:DWORD

;GdipGetStringFormatTabStops  StringFormat:DWORD, count:DWORD, firstTabOffset:REAL4, tabStops:REAL4
GdipGetStringFormatTabStops PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipGetStringFormatTrimming  StringFormat:DWORD, trimming:DWORD
GdipGetStringFormatTrimming PROTO :DWORD,:DWORD

;GdipGetTextContrast  graphics:DWORD, contrast:DWORD
GdipGetTextContrast PROTO :DWORD,:DWORD

;GdipGetTextRenderingHint  graphics:DWORD, Mode:TextRenderingHint
GdipGetTextRenderingHint PROTO :DWORD,:DWORD

;GdipGetTextureImage  brush:DWORD, image:DWORD
GdipGetTextureImage PROTO :DWORD,:DWORD

;GdipGetTextureTransform  brush:DWORD, matrix:DWORD
GdipGetTextureTransform PROTO :DWORD,:DWORD

;GdipGetTextureWrapMode  brush:DWORD, WrapMd:WrapMode
GdipGetTextureWrapMode PROTO :DWORD,:DWORD

;GdipGetVisibleClipBounds  graphics:DWORD, RECT:RECTF
GdipGetVisibleClipBounds PROTO :DWORD,:DWORD

;GdipGetVisibleClipBoundsI  graphics:DWORD, RECT:RECTL
GdipGetVisibleClipBoundsI PROTO :DWORD,:DWORD

;GdipGetWorldTransform  graphics:DWORD, matrix:DWORD
GdipGetWorldTransform PROTO :DWORD,:DWORD

;GdipGraphicsClear  graphics:DWORD, lcolor:DWORD
GdipGraphicsClear PROTO :DWORD,:DWORD

;GdipImageForceValidation  image:DWORD
GdipImageForceValidation PROTO :DWORD

;GdipImageGetFrameCount  image:DWORD, dimensionID:CLSID, count:DWORD
GdipImageGetFrameCount PROTO :DWORD,:DWORD,:DWORD

;GdipImageGetFrameDimensionsCount  image:DWORD, count:DWORD
GdipImageGetFrameDimensionsCount PROTO :DWORD,:DWORD

;GdipImageGetFrameDimensionsList  image:DWORD, dimensionIDs:CLSID, count:DWORD
GdipImageGetFrameDimensionsList PROTO :DWORD,:DWORD,:DWORD

;GdipImageRotateFlip  image:DWORD, rfType:RotateFlipType
GdipImageRotateFlip PROTO :DWORD,:DWORD

;GdipImageSelectActiveFrame  image:DWORD, dimensionID:CLSID, frameIndex:DWORD
GdipImageSelectActiveFrame PROTO :DWORD,:DWORD,:DWORD

;GdipInvertMatrix  matrix:DWORD
GdipInvertMatrix PROTO :DWORD

;GdipIsClipEmpty  graphics:DWORD, result:DWORD
GdipIsClipEmpty PROTO :DWORD,:DWORD

;GdipIsEmptyRegion  region:DWORD, graphics:DWORD, result:DWORD
GdipIsEmptyRegion PROTO :DWORD,:DWORD,:DWORD

;GdipIsEqualRegion  region:DWORD, region2:DWORD, graphics:DWORD, result:DWORD
GdipIsEqualRegion PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipIsInfiniteRegion  region:DWORD, graphics:DWORD, result:DWORD
GdipIsInfiniteRegion PROTO :DWORD,:DWORD,:DWORD

;GdipIsMatrixEqual  matrix:DWORD, matrix2:DWORD, result:DWORD
GdipIsMatrixEqual PROTO :DWORD,:DWORD,:DWORD

;GdipIsMatrixIdentity  matrix:DWORD, result:DWORD
GdipIsMatrixIdentity PROTO :DWORD,:DWORD

;GdipIsMatrixInvertible  matrix:DWORD, result:DWORD
GdipIsMatrixInvertible PROTO :DWORD,:DWORD

;GdipIsOutlineVisiblePathPoint  path:DWORD, x:REAL4, Y:REAL4, pen:DWORD, graphics:DWORD, result:DWORD
GdipIsOutlineVisiblePathPoint PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipIsOutlineVisiblePathPointI  path:DWORD, x:DWORD, Y:DWORD, pen:DWORD, graphics:DWORD, result:DWORD
GdipIsOutlineVisiblePathPointI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipIsStyleAvailable  family:DWORD, Style:DWORD, IsStyleAvailable:DWORD
GdipIsStyleAvailable PROTO :DWORD,:DWORD,:DWORD

;GdipIsVisibleClipEmpty  graphics:DWORD, result:DWORD
GdipIsVisibleClipEmpty PROTO :DWORD,:DWORD

;GdipIsVisiblePathPoint  path:DWORD, x:REAL4, Y:REAL4, graphics:DWORD, result:DWORD
GdipIsVisiblePathPoint PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipIsVisiblePathPointI  path:DWORD, x:DWORD, Y:DWORD, graphics:DWORD, result:DWORD
GdipIsVisiblePathPointI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipIsVisiblePoint  graphics:DWORD, x:REAL4, Y:REAL4, result:DWORD
GdipIsVisiblePoint PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipIsVisiblePointI  graphics:DWORD, x:DWORD, Y:DWORD, result:DWORD
GdipIsVisiblePointI PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipIsVisibleRect  graphics:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4, result:DWORD
GdipIsVisibleRect PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipIsVisibleRectI  graphics:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD, result:DWORD
GdipIsVisibleRectI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipIsVisibleRegionPoint  region:DWORD, x:REAL4, Y:REAL4, graphics:DWORD, result:DWORD
GdipIsVisibleRegionPoint PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipIsVisibleRegionPointI  region:DWORD, x:DWORD, Y:DWORD, graphics:DWORD, result:DWORD
GdipIsVisibleRegionPointI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipIsVisibleRegionRect  region:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4, graphics:DWORD, result:DWORD
GdipIsVisibleRegionRect PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipIsVisibleRegionRectI  region:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD, graphics:DWORD, result:DWORD
GdipIsVisibleRegionRectI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD



GdiplusNotificationHook PROTO :DWORD

GdiplusNotificationUnhook PROTO :DWORD

;GdiplusShutdown  token:DWORD
GdiplusShutdown PROTO :DWORD

;GdiplusStartup  token:DWORD, inputbuf:GdiplusStartupInput, Optional outputbuf:DWORD = 0
GdiplusStartup PROTO :DWORD,:DWORD,:DWORD

;GdipMeasureCharacterRanges  graphics:DWORD, str:String, Length:DWORD, thefont:DWORD, layoutRect:RECTF, StringFormat:DWORD, regionCount:DWORD, regions:DWORD
GdipMeasureCharacterRanges PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipMeasureDriverString  graphics:DWORD, str:String, Length:DWORD, thefont:DWORD, positions:POINTF, Flags:DWORD, matrix:DWORD, boundingBox:RECTF
GdipMeasureDriverString PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipMeasureString  graphics:DWORD, str:String, Length:DWORD, thefont:DWORD, layoutRect:RECTF, StringFormat:DWORD, boundingBox:RECTF, codepointsFitted:DWORD, linesFilled:DWORD
GdipMeasureString PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipMultiplyLineTransform  brush:DWORD, matrix:DWORD, order:MatrixOrder
GdipMultiplyLineTransform PROTO :DWORD,:DWORD,:DWORD

;GdipMultiplyMatrix  matrix:DWORD, matrix2:DWORD, order:MatrixOrder
GdipMultiplyMatrix PROTO :DWORD,:DWORD,:DWORD

;GdipMultiplyPathGradientTransform  brush:DWORD, matrix:DWORD, order:MatrixOrder
GdipMultiplyPathGradientTransform PROTO :DWORD,:DWORD,:DWORD

;GdipMultiplyPenTransform  pen:DWORD, matrix:DWORD, order:MatrixOrder
GdipMultiplyPenTransform PROTO :DWORD,:DWORD,:DWORD

;GdipMultiplyTextureTransform  brush:DWORD, matrix:DWORD, order:MatrixOrder
GdipMultiplyTextureTransform PROTO :DWORD,:DWORD,:DWORD

;GdipMultiplyWorldTransform  graphics:DWORD, matrix:DWORD, order:MatrixOrder
GdipMultiplyWorldTransform PROTO :DWORD,:DWORD,:DWORD

;GdipNewInstalledFontCollection  fontCollection:DWORD
GdipNewInstalledFontCollection PROTO :DWORD

;GdipNewPrivateFontCollection  fontCollection:DWORD
GdipNewPrivateFontCollection PROTO :DWORD

;GdipPathIterCopyData  iterator:DWORD, resultCount:DWORD, Points:POINTF, types:Any, startIndex:DWORD, endIndex:DWORD
GdipPathIterCopyData PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipPathIterEnumerate  iterator:DWORD, resultCount:DWORD, Points:POINTF, types:Any, count:DWORD
GdipPathIterEnumerate PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipPathIterGetCount  iterator:DWORD, count:DWORD
GdipPathIterGetCount PROTO :DWORD,:DWORD

;GdipPathIterGetSubpathCount  iterator:DWORD, count:DWORD
GdipPathIterGetSubpathCount PROTO :DWORD,:DWORD

;GdipPathIterHasCurve  iterator:DWORD, hasCurve:DWORD
GdipPathIterHasCurve PROTO :DWORD,:DWORD

;GdipPathIterIsValid  iterator:DWORD, valid:DWORD
GdipPathIterIsValid PROTO :DWORD,:DWORD

;GdipPathIterNextMarker  iterator:DWORD, resultCount:DWORD, startIndex:DWORD, endIndex:DWORD
GdipPathIterNextMarker PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipPathIterNextMarkerPath  iterator:DWORD, resultCount:DWORD, path:DWORD
GdipPathIterNextMarkerPath PROTO :DWORD,:DWORD,:DWORD

;GdipPathIterNextPathType  iterator:DWORD, resultCount:DWORD, pathType:Any, startIndex:DWORD, endIndex:DWORD
GdipPathIterNextPathType PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipPathIterNextSubpath  iterator:DWORD, resultCount:DWORD, startIndex:DWORD, endIndex:DWORD, isClosed:DWORD
GdipPathIterNextSubpath PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipPathIterNextSubpathPath  iterator:DWORD, resultCount:DWORD, path:DWORD, isClosed:DWORD
GdipPathIterNextSubpathPath PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipPathIterRewind  iterator:DWORD
GdipPathIterRewind PROTO :DWORD

;GdipPlayMetafileRecord  metafile:DWORD, recordType:EmfPlusRecordType, Flags:DWORD, dataSize:DWORD, byteData:Any
GdipPlayMetafileRecord PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipPrivateAddFontFile  fontCollection:DWORD, Filename:String
GdipPrivateAddFontFile PROTO :DWORD,:DWORD

;GdipPrivateAddMemoryFont  fontCollection:DWORD, memory:DWORD, Length:DWORD
GdipPrivateAddMemoryFont PROTO :DWORD,:DWORD,:DWORD

;GdipRecordMetafile  referenceHdc:DWORD, etype:EmfType, frameRect:RECTF, frameUnit:MetafileFrameUnit, description:String, metafile:DWORD
GdipRecordMetafile PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipRecordMetafileFileName  Filename:String, referenceHdc:DWORD, etype:EmfType, frameRect:RECTF, frameUnit:MetafileFrameUnit, description:String, metafile:DWORD
GdipRecordMetafileFileName PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipRecordMetafileFileNameI  Filename:String, referenceHdc:DWORD, etype:EmfType, frameRect:RECTL, frameUnit:MetafileFrameUnit, description:String, metafile:DWORD
GdipRecordMetafileFileNameI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipRecordMetafileI  referenceHdc:DWORD, etype:EmfType, frameRect:RECTL, frameUnit:MetafileFrameUnit, description:String, metafile:DWORD
GdipRecordMetafileI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipRecordMetafileStream  stream:IStream, referenceHdc:DWORD, etype:EmfType, frameRect:RECTF, frameUnit:MetafileFrameUnit, description:String, metafile:DWORD
GdipRecordMetafileStream PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipRecordMetafileStreamI  stream:IStream, referenceHdc:DWORD, etype:EmfType, frameRect:RECTL, frameUnit:MetafileFrameUnit, description:String, metafile:DWORD
GdipRecordMetafileStreamI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipReleaseDC  graphics:DWORD, hdc:DWORD
GdipReleaseDC PROTO :DWORD,:DWORD

GdipRemoveImageCodec PROTO :DWORD



;GdipResetClip  graphics:DWORD
GdipResetClip PROTO :DWORD

;GdipResetImageAttributes  imageattr:DWORD, ClrAdjType:ColorAdjustType
GdipResetImageAttributes PROTO :DWORD,:DWORD

;GdipResetLineTransform  brush:DWORD
GdipResetLineTransform PROTO :DWORD

;GdipResetPageTransform  graphics:DWORD
GdipResetPageTransform PROTO :DWORD

;GdipResetPath  path:DWORD
GdipResetPath PROTO :DWORD

;GdipResetPathGradientTransform  brush:DWORD
GdipResetPathGradientTransform PROTO :DWORD

;GdipResetPenTransform  pen:DWORD
GdipResetPenTransform PROTO :DWORD

;GdipResetTextureTransform  brush:DWORD
GdipResetTextureTransform PROTO :DWORD

;GdipResetWorldTransform  graphics:DWORD
GdipResetWorldTransform PROTO :DWORD

;GdipRestoreGraphics  graphics:DWORD, State:DWORD
GdipRestoreGraphics PROTO :DWORD,:DWORD

;GdipReversePath  path:DWORD
GdipReversePath PROTO :DWORD

;GdipRotateLineTransform  brush:DWORD, angle:REAL4, order:MatrixOrder
GdipRotateLineTransform PROTO :DWORD,:DWORD,:DWORD

;GdipRotateMatrix  matrix:DWORD, angle:REAL4, order:MatrixOrder
GdipRotateMatrix PROTO :DWORD,:DWORD,:DWORD

;GdipRotatePathGradientTransform  brush:DWORD, angle:REAL4, order:MatrixOrder
GdipRotatePathGradientTransform PROTO :DWORD,:DWORD,:DWORD

;GdipRotatePenTransform  pen:DWORD, angle:REAL4, order:MatrixOrder
GdipRotatePenTransform PROTO :DWORD,:DWORD,:DWORD

;GdipRotateTextureTransform  brush:DWORD, angle:REAL4, order:MatrixOrder
GdipRotateTextureTransform PROTO :DWORD,:DWORD,:DWORD

;GdipRotateWorldTransform  graphics:DWORD, angle:REAL4, order:MatrixOrder
GdipRotateWorldTransform PROTO :DWORD,:DWORD,:DWORD

;GdipSaveAdd  image:DWORD, encoderParams:EncoderParameters
GdipSaveAdd PROTO :DWORD,:DWORD

;GdipSaveAddImage  image:DWORD, newImage:DWORD, encoderParams:EncoderParameters
GdipSaveAddImage PROTO :DWORD,:DWORD,:DWORD

;GdipSaveGraphics  graphics:DWORD, State:DWORD
GdipSaveGraphics PROTO :DWORD,:DWORD

;GdipSaveImageToFile  image:DWORD, Filename:String, clsidEncoder:CLSID, encoderParams:Any
GdipSaveImageToFile PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipSaveImageToStream  image:DWORD, stream:IStream, clsidEncoder:CLSID, encoderParams:Any
GdipSaveImageToStream PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipScaleLineTransform  brush:DWORD, sx:REAL4, sy:REAL4, order:MatrixOrder
GdipScaleLineTransform PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipScaleMatrix  matrix:DWORD, scaleX:REAL4, scaleY:REAL4, order:MatrixOrder
GdipScaleMatrix PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipScalePathGradientTransform  brush:DWORD, sx:REAL4, sy:REAL4, order:MatrixOrder
GdipScalePathGradientTransform PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipScalePenTransform  pen:DWORD, sx:REAL4, sy:REAL4, order:MatrixOrder
GdipScalePenTransform PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipScaleTextureTransform  brush:DWORD, sx:REAL4, sy:REAL4, order:MatrixOrder
GdipScaleTextureTransform PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipScaleWorldTransform  graphics:DWORD, sx:REAL4, sy:REAL4, order:MatrixOrder
GdipScaleWorldTransform PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipSetAdjustableArrowCapFillState  cap:DWORD, bFillState:DWORD
GdipSetAdjustableArrowCapFillState PROTO :DWORD,:DWORD

;GdipSetAdjustableArrowCapHeight  cap:DWORD, Height:REAL4
GdipSetAdjustableArrowCapHeight PROTO :DWORD,:DWORD

;GdipSetAdjustableArrowCapMiddleInset  cap:DWORD, middleInset:REAL4
GdipSetAdjustableArrowCapMiddleInset PROTO :DWORD,:DWORD

;GdipSetAdjustableArrowCapWidth  cap:DWORD, Width:REAL4
GdipSetAdjustableArrowCapWidth PROTO :DWORD,:DWORD

;GdipSetClipGraphics  graphics:DWORD, srcgraphics:DWORD, CombineMd:CombineMode
GdipSetClipGraphics PROTO :DWORD,:DWORD,:DWORD

;GdipSetClipHrgn  graphics:DWORD, hRgn:DWORD, CombineMd:CombineMode
GdipSetClipHrgn PROTO :DWORD,:DWORD,:DWORD

;GdipSetClipPath  graphics:DWORD, path:DWORD, CombineMd:CombineMode
GdipSetClipPath PROTO :DWORD,:DWORD,:DWORD

;GdipSetClipRect  graphics:DWORD, x:REAL4, Y:REAL4, Width:REAL4, Height:REAL4, CombineMd:CombineMode
GdipSetClipRect PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipSetClipRectI  graphics:DWORD, x:DWORD, Y:DWORD, Width:DWORD, Height:DWORD, CombineMd:CombineMode
GdipSetClipRectI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipSetClipRegion  graphics:DWORD, region:DWORD, CombineMd:CombineMode
GdipSetClipRegion PROTO :DWORD,:DWORD,:DWORD

;GdipSetCompositingMode  graphics:DWORD, CompositingMd:CompositingMode
GdipSetCompositingMode PROTO :DWORD,:DWORD

;GdipSetCompositingQuality  graphics:DWORD, CompositingQlty:CompositingQuality
GdipSetCompositingQuality PROTO :DWORD,:DWORD

;GdipSetCustomLineCapBaseCap  customCap:DWORD, baseCap:LineCap
GdipSetCustomLineCapBaseCap PROTO :DWORD,:DWORD

;GdipSetCustomLineCapBaseInset  customCap:DWORD, inset:REAL4
GdipSetCustomLineCapBaseInset PROTO :DWORD,:DWORD

;GdipSetCustomLineCapStrokeCaps  customCap:DWORD, startCap:LineCap, endCap:LineCap
GdipSetCustomLineCapStrokeCaps PROTO :DWORD,:DWORD,:DWORD

;GdipSetCustomLineCapStrokeJoin  customCap:DWORD, LnJoin:LineJoin
GdipSetCustomLineCapStrokeJoin PROTO :DWORD,:DWORD

;GdipSetCustomLineCapWidthScale  customCap:DWORD, widthScale:REAL4
GdipSetCustomLineCapWidthScale PROTO :DWORD,:DWORD

;GdipSetEmpty  region:DWORD
GdipSetEmpty PROTO :DWORD

GdipSetGraphicsLayout PROTO :DWORD,:DWORD

GdipSetImageAttributesCachedBackground PROTO :DWORD,:DWORD

;GdipSetImageAttributesColorKeys  imageattr:DWORD, ClrAdjType:ColorAdjustType, enableFlag:DWORD, colorLow:DWORD, colorHigh:DWORD
GdipSetImageAttributesColorKeys PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipSetImageAttributesColorMatrix  imageattr:DWORD, ClrAdjType:ColorAdjustType, enableFlag:DWORD, colourMatrix:ColorMatrix, grayMatrix:Any, Flags:ColorMatrixFlags
GdipSetImageAttributesColorMatrix PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipSetImageAttributesGamma  imageattr:DWORD, ClrAdjType:ColorAdjustType, enableFlag:DWORD, gamma:REAL4
GdipSetImageAttributesGamma PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipSetImageAttributesICMMode  imageattr:DWORD, bOn:DWORD

;GdipSetImageAttributesNoOp  imageattr:DWORD, ClrAdjType:ColorAdjustType, enableFlag:DWORD
GdipSetImageAttributesNoOp PROTO :DWORD,:DWORD,:DWORD

;GdipSetImageAttributesOutputChannel  imageattr:DWORD, ClrAdjstType:ColorAdjustType, enableFlag:DWORD, channelFlags:ColorChannelFlags
GdipSetImageAttributesOutputChannel PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipSetImageAttributesOutputChannelColorProfile  imageattr:DWORD, ClrAdjType:ColorAdjustType, enableFlag:DWORD, colorProfileFilename:String
GdipSetImageAttributesOutputChannelColorProfile PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipSetImageAttributesRemapTable  imageattr:DWORD, ClrAdjType:ColorAdjustType, enableFlag:DWORD, mapSize:DWORD, map:ColorMap
GdipSetImageAttributesRemapTable PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipSetImageAttributesThreshold  imageattr:DWORD, ClrAdjType:ColorAdjustType, enableFlag:DWORD, threshold:REAL4
GdipSetImageAttributesThreshold PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipSetImageAttributesToIdentity  imageattr:DWORD, ClrAdjType:ColorAdjustType
GdipSetImageAttributesToIdentity PROTO :DWORD,:DWORD

;GdipSetImageAttributesWrapMode  imageattr:DWORD, wrap:WrapMode, argb:DWORD, bClamp:DWORD
GdipSetImageAttributesWrapMode PROTO :DWORD,:DWORD,:DWORD,:DWORD

GdipSetImageLayout PROTO :DWORD,:DWORD

;GdipSetImagePalette  image:DWORD, palette:ColorPalette
GdipSetImagePalette PROTO :DWORD,:DWORD

;GdipSetInfinite  region:DWORD
GdipSetInfinite PROTO :DWORD

;GdipSetInterpolationMode  graphics:DWORD, interpolation:InterpolationMode
GdipSetInterpolationMode PROTO :DWORD,:DWORD

;GdipSetLineBlend  brush:DWORD, blend:REAL4, positions:REAL4, count:DWORD
GdipSetLineBlend PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipSetLineColors  brush:DWORD, color1:DWORD, color2:DWORD
GdipSetLineColors PROTO :DWORD,:DWORD,:DWORD

;GdipSetLineGammaCorrection  brush:DWORD, useGammaCorrection:DWORD
GdipSetLineGammaCorrection PROTO :DWORD,:DWORD

;GdipSetLineLinearBlend  brush:DWORD, focus:REAL4, theScale:REAL4
GdipSetLineLinearBlend PROTO :DWORD,:DWORD,:DWORD

GdipSetLinePoints PROTO :DWORD,:DWORD,:DWORD

GdipSetLinePointsI PROTO :DWORD,:DWORD,:DWORD

;GdipSetLinePresetBlend  brush:DWORD, blend:DWORD, positions:REAL4, count:DWORD
GdipSetLinePresetBlend PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipSetLineSigmaBlend  brush:DWORD, focus:REAL4, theScale:REAL4
GdipSetLineSigmaBlend PROTO :DWORD,:DWORD,:DWORD

;GdipSetLineTransform  brush:DWORD, matrix:DWORD
GdipSetLineTransform PROTO :DWORD,:DWORD

;GdipSetLineWrapMode  brush:DWORD, WrapMd:WrapMode
GdipSetLineWrapMode PROTO :DWORD,:DWORD

;GdipSetMatrixElements  matrix:DWORD, m11:REAL4, m12:REAL4, m21:REAL4, m22:REAL4, dx:REAL4, dy:REAL4
GdipSetMatrixElements PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipSetMetafileDownLevelRasterizationLimit  metafile:DWORD, metafileRasterizationLimitDpi:DWORD
GdipSetMetafileDownLevelRasterizationLimit PROTO :DWORD,:DWORD

;GdipSetPageScale  graphics:DWORD, sscale:REAL4
GdipSetPageScale PROTO :DWORD,:DWORD

;GdipSetPageUnit  graphics:DWORD, unit:GpUnit
GdipSetPageUnit PROTO :DWORD,:DWORD

;GdipSetPathFillMode  path:DWORD, brushmode:FillMode
GdipSetPathFillMode PROTO :DWORD,:DWORD

;GdipSetPathGradientBlend  brush:DWORD, blend:REAL4, positions:REAL4, count:DWORD
GdipSetPathGradientBlend PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipSetPathGradientCenterColor  brush:DWORD, lColors:DWORD
GdipSetPathGradientCenterColor PROTO :DWORD,:DWORD

;GdipSetPathGradientCenterPoint  brush:DWORD, Points:POINTF
GdipSetPathGradientCenterPoint PROTO :DWORD,:DWORD

;GdipSetPathGradientCenterPointI  brush:DWORD, Points:POINTL
GdipSetPathGradientCenterPointI PROTO :DWORD,:DWORD

;GdipSetPathGradientFocusScales  brush:DWORD, xScale:REAL4, yScale:REAL4
GdipSetPathGradientFocusScales PROTO :DWORD,:DWORD,:DWORD

;GdipSetPathGradientGammaCorrection  brush:DWORD, useGammaCorrection:DWORD
GdipSetPathGradientGammaCorrection PROTO :DWORD,:DWORD

;GdipSetPathGradientLinearBlend  brush:DWORD, focus:REAL4, sscale:REAL4
GdipSetPathGradientLinearBlend PROTO :DWORD,:DWORD,:DWORD

;GdipSetPathGradientPath  brush:DWORD, path:DWORD
GdipSetPathGradientPath PROTO :DWORD,:DWORD

;GdipSetPathGradientPresetBlend  brush:DWORD, blend:DWORD, positions:REAL4, count:DWORD
GdipSetPathGradientPresetBlend PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipSetPathGradientSigmaBlend  brush:DWORD, focus:REAL4, sscale:REAL4
GdipSetPathGradientSigmaBlend PROTO :DWORD,:DWORD,:DWORD

;GdipSetPathGradientSurroundColorsWithCount  brush:DWORD, argb:DWORD, count:DWORD
GdipSetPathGradientSurroundColorsWithCount PROTO :DWORD,:DWORD,:DWORD

;GdipSetPathGradientTransform  brush:DWORD, matrix:DWORD
GdipSetPathGradientTransform PROTO :DWORD,:DWORD

;GdipSetPathGradientWrapMode  brush:DWORD, WrapMd:WrapMode
GdipSetPathGradientWrapMode PROTO :DWORD,:DWORD

;GdipSetPathMarker  path:DWORD
GdipSetPathMarker PROTO :DWORD

;GdipSetPenBrushFill  pen:DWORD, brush:DWORD
GdipSetPenBrushFill PROTO :DWORD,:DWORD

;GdipSetPenColor  pen:DWORD, argb:DWORD
GdipSetPenColor PROTO :DWORD,:DWORD

;GdipSetPenCompoundArray  pen:DWORD, dash:REAL4, count:DWORD
GdipSetPenCompoundArray PROTO :DWORD,:DWORD,:DWORD

;GdipSetPenCustomEndCap  pen:DWORD, customCap:DWORD
GdipSetPenCustomEndCap PROTO :DWORD,:DWORD

;GdipSetPenCustomStartCap  pen:DWORD, customCap:DWORD
GdipSetPenCustomStartCap PROTO :DWORD,:DWORD

;GdipSetPenDashArray  pen:DWORD, dash:REAL4, count:DWORD
GdipSetPenDashArray PROTO :DWORD,:DWORD,:DWORD

;GdipSetPenDashCap  pen:DWORD, dcap:DashCap
GdipSetPenDashCap197819 PROTO :DWORD,:DWORD

;GdipSetPenDashOffset  pen:DWORD, Offset:REAL4
GdipSetPenDashOffset PROTO :DWORD,:DWORD

;GdipSetPenDashStyle  pen:DWORD, dStyle:DashStyle
GdipSetPenDashStyle PROTO :DWORD,:DWORD

;GdipSetPenEndCap  pen:DWORD, endCap:LineCap
GdipSetPenEndCap PROTO :DWORD,:DWORD

;GdipSetPenLineCap  pen:DWORD, startCap:LineCap, endCap:LineCap, dcap:DashCap
GdipSetPenLineCap197819 PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipSetPenLineJoin  pen:DWORD, LnJoin:LineJoin
GdipSetPenLineJoin PROTO :DWORD,:DWORD

;GdipSetPenMiterLimit  pen:DWORD, miterLimit:REAL4
GdipSetPenMiterLimit PROTO :DWORD,:DWORD

;GdipSetPenMode  pen:DWORD, penMode:PenAlignment
GdipSetPenMode PROTO :DWORD,:DWORD

;GdipSetPenStartCap  pen:DWORD, startCap:LineCap
GdipSetPenStartCap PROTO :DWORD,:DWORD

;GdipSetPenTransform  pen:DWORD, matrix:DWORD
GdipSetPenTransform PROTO :DWORD,:DWORD

;GdipSetPenUnit  pen:DWORD, unit:GpUnit
GdipSetPenUnit PROTO :DWORD,:DWORD

;GdipSetPenWidth  pen:DWORD, Width:REAL4
GdipSetPenWidth PROTO :DWORD,:DWORD

;GdipSetPixelOffsetMode  graphics:DWORD, PixOffsetMode:PixelOffsetMode
GdipSetPixelOffsetMode PROTO :DWORD,:DWORD



;GdipSetRenderingOrigin  graphics:DWORD, x:DWORD, Y:DWORD
GdipSetRenderingOrigin PROTO :DWORD,:DWORD,:DWORD

;GdipSetSmoothingMode  graphics:DWORD, SmoothingMd:SmoothingMode
GdipSetSmoothingMode PROTO :DWORD,:DWORD

;GdipSetSolidFillColor  brush:DWORD, argb:DWORD
GdipSetSolidFillColor PROTO :DWORD,:DWORD

;GdipSetStringFormatAlign  StringFormat:DWORD, align:StringAlignment
GdipSetStringFormatAlign PROTO :DWORD,:DWORD

;GdipSetStringFormatDigitSubstitution  StringFormat:DWORD, language:Integer, substitute:StringDigitSubstitute
GdipSetStringFormatDigitSubstitution PROTO :DWORD,:DWORD,:DWORD

;GdipSetStringFormatFlags  StringFormat:DWORD, Flags:DWORD
GdipSetStringFormatFlags PROTO :DWORD,:DWORD

;GdipSetStringFormatHotkeyPrefix  StringFormat:DWORD, hkPrefix:HotkeyPrefix
GdipSetStringFormatHotkeyPrefix PROTO :DWORD,:DWORD

;GdipSetStringFormatLineAlign  StringFormat:DWORD, align:StringAlignment
GdipSetStringFormatLineAlign PROTO :DWORD,:DWORD

;GdipSetStringFormatMeasurableCharacterRanges  StringFormat:DWORD, rangeCount:DWORD, ranges:CharacterRange
GdipSetStringFormatMeasurableCharacterRanges PROTO :DWORD,:DWORD,:DWORD

;GdipSetStringFormatTabStops  StringFormat:DWORD, firstTabOffset:REAL4, count:DWORD, tabStops:REAL4
GdipSetStringFormatTabStops PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipSetStringFormatTrimming  StringFormat:DWORD, trimming:StringTrimming
GdipSetStringFormatTrimming PROTO :DWORD,:DWORD

;GdipSetTextContrast  graphics:DWORD, contrast:DWORD
GdipSetTextContrast PROTO :DWORD,:DWORD

;GdipSetTextRenderingHint  graphics:DWORD, Mode:TextRenderingHint
GdipSetTextRenderingHint PROTO :DWORD,:DWORD

;GdipSetTextureTransform  brush:DWORD, matrix:DWORD
GdipSetTextureTransform PROTO :DWORD,:DWORD

;GdipSetTextureWrapMode  brush:DWORD, WrapMd:WrapMode
GdipSetTextureWrapMode PROTO :DWORD,:DWORD

;GdipSetWorldTransform  graphics:DWORD, matrix:DWORD
GdipSetWorldTransform PROTO :DWORD,:DWORD

;GdipShearMatrix  matrix:DWORD, shearX:REAL4, shearY:REAL4, order:MatrixOrder
GdipShearMatrix PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipStartPathFigure  path:DWORD
GdipStartPathFigure PROTO :DWORD

;GdipStringFormatGetGenericDefault  StringFormat:DWORD
GdipStringFormatGetGenericDefault PROTO :DWORD

;GdipStringFormatGetGenericTypographic  StringFormat:DWORD
GdipStringFormatGetGenericTypographic PROTO :DWORD

GdipTestControl PROTO :DWORD,:DWORD

;GdipTransformMatrixPoints  matrix:DWORD, pts:POINTF, count:DWORD
GdipTransformMatrixPoints PROTO :DWORD,:DWORD,:DWORD

;GdipTransformMatrixPointsI  matrix:DWORD, pts:POINTL, count:DWORD
GdipTransformMatrixPointsI PROTO :DWORD,:DWORD,:DWORD

;GdipTransformPath  path:DWORD, matrix:DWORD
GdipTransformPath PROTO :DWORD,:DWORD

;GdipTransformPoints  graphics:DWORD, destSpace:CoordinateSpace, srcSpace:CoordinateSpace, Points:POINTF, count:DWORD
GdipTransformPoints PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipTransformPointsI  graphics:DWORD, destSpace:CoordinateSpace, srcSpace:CoordinateSpace, Points:POINTL, count:DWORD
GdipTransformPointsI PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipTransformRegion  region:DWORD, matrix:DWORD
GdipTransformRegion PROTO :DWORD,:DWORD

;GdipTranslateClip  graphics:DWORD, dx:REAL4, dy:REAL4
GdipTranslateClip PROTO :DWORD,:DWORD,:DWORD

;GdipTranslateClipI  graphics:DWORD, dx:DWORD, dy:DWORD
GdipTranslateClipI PROTO :DWORD,:DWORD,:DWORD

;GdipTranslateLineTransform  brush:DWORD, dx:REAL4, dy:REAL4, order:MatrixOrder
GdipTranslateLineTransform PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipTranslateMatrix  matrix:DWORD, offsetX:REAL4, offsetY:REAL4, order:MatrixOrder
GdipTranslateMatrix PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipTranslatePathGradientTransform  brush:DWORD, dx:REAL4, dy:REAL4, order:MatrixOrder
GdipTranslatePathGradientTransform PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipTranslatePenTransform  pen:DWORD, dx:REAL4, dy:REAL4, order:MatrixOrder
GdipTranslatePenTransform PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipTranslateRegion  region:DWORD, dx:REAL4, dy:REAL4
GdipTranslateRegion PROTO :DWORD,:DWORD,:DWORD

;GdipTranslateRegionI  region:DWORD, dx:DWORD, dy:DWORD
GdipTranslateRegionI PROTO :DWORD,:DWORD,:DWORD

;GdipTranslateTextureTransform  brush:DWORD, dx:REAL4, dy:REAL4, order:MatrixOrder
GdipTranslateTextureTransform PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipTranslateWorldTransform  graphics:DWORD, dx:REAL4, dy:REAL4, order:MatrixOrder
GdipTranslateWorldTransform PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipVectorTransformMatrixPoints  matrix:DWORD, pts:POINTF, count:DWORD
GdipVectorTransformMatrixPoints PROTO :DWORD,:DWORD,:DWORD

;GdipVectorTransformMatrixPointsI  matrix:DWORD, pts:POINTL, count:DWORD
GdipVectorTransformMatrixPointsI PROTO :DWORD,:DWORD,:DWORD

;GdipWarpPath  path:DWORD, matrix:DWORD, Points:POINTF, count:DWORD, srcx:REAL4, srcy:REAL4, srcwidth:REAL4, srcheight:REAL4, WarpMd:WarpMode, flatness:REAL4
GdipWarpPath PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;GdipWidenPath  nativePath:DWORD, pen:DWORD, matrix:DWORD, flatness:REAL4
GdipWidenPath PROTO :DWORD,:DWORD,:DWORD,:DWORD

;GdipWindingModeOutline  path:DWORD, matrix:DWORD, flatness:REAL4
GdipWindingModeOutline PROTO :DWORD,:DWORD,:DWORD
