						.Code

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

Bitmap_CountColors		PROC	USES EDI ESI
						LOCAL	dwIndex:DWord
						LOCAL	bIndex:DWord
	
;	============================================================
;	=== Compter le nombre de couleurs prsentes dans l'image ===
;	============================================================

						mov		DWord Ptr dwIndex,0					; Index dans la liste des couleurs
						mov		DWord Ptr [dwColorsCount],0			; Compteur du nombre de couleurs
						mov		edi,DWord Ptr [Image.bmHeight]		; Hauteur de l'image
						mov		edx,DWord Ptr [lpdwColors]			; Tableau des couleurs
						mov		ebx,DWord Ptr [lpImageBits]			; Bits de l'image

Bitmap_CountColors_Loop :

						mov		esi,DWord Ptr [Image.bmWidth]		; Largeur de l'image

Bitmap_CountColors_Loop_1 :

						mov		eax,DWord Ptr [ebx]					; Charger la valeur de la couleur
						mov		ecx,eax
						shl		ecx,4								; SIZEOF COLORS_SEARCH

						mov		DWord Ptr [bIndex],FALSE

						cmp		DWord Ptr (COLORS_SEARCH Ptr [edx + ecx]).dwCount,0	; Cette couleur a-t-elle t rencontre ?
						jne		Bitmap_CountColors_Loop_2

						mov		DWord Ptr [bIndex],TRUE

						inc		DWord Ptr [dwColorsCount]			; Incrmenter le compteur des couleurs
						inc		DWord Ptr [dwIndex]					; Incrmenter l'index des couleurs

Bitmap_CountColors_Loop_2 :

						mov		DWord Ptr (COLORS_SEARCH Ptr [edx + ecx]).dwColor,eax
						inc		DWord Ptr (COLORS_SEARCH Ptr [edx + ecx]).dwCount	; Incrmenter le compteur de cette couleur

						cmp		DWord Ptr [bIndex],FALSE	; Cette couleur a-t-elle t rencontre ?
						je		Bitmap_CountColors_Loop_3

						mov		eax,DWord Ptr [dwIndex]
						mov		DWord Ptr (COLORS_SEARCH Ptr [edx + ecx]).dwIndex,eax

						mov		eax,DWord Ptr (COLORS_SEARCH Ptr [edx + ecx]).dwColor

						push	ebx
						mov		ebx,eax

						and		ebx,0ff0000h
						shr		ebx,16
						mov		DWord Ptr (COLORS_SEARCH Ptr [edx + ecx]).dwRed,ebx

						mov		ebx,eax

						and		ebx,0ff00h
						shr		ebx,8
						mov		DWord Ptr (COLORS_SEARCH Ptr [edx + ecx]).dwGreen,ebx

						and		eax,0ffh
						mov		DWord Ptr (COLORS_SEARCH Ptr [edx + ecx]).dwBlue,eax

						pop		ebx

Bitmap_CountColors_Loop_3 :

						add		ebx,SIZEOF DWord

						dec		esi									; Colonne suivante
						jnz		Bitmap_CountColors_Loop_1			; Toute la ligne a t traite ?


						dec		edi									; Ligne suivante
						jnz		Bitmap_CountColors_Loop				; Toutes les lignes ont t traites ?

						ret
Bitmap_CountColors		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################
