;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

Colors_SetColums		PROC	USES EDI ESI,hWnd:HWND
						LOCAL	LvCol:LVCOLUMN

						mov		edi,DWord Ptr [hWnd]			; Handle de la LISTBOX
						lea		esi,LvCol

						INVOKE	SendMessage,edi,LVM_SETTEXTCOLOR,0,00ffff00h
						INVOKE	SendMessage,edi,LVM_SETBKCOLOR,0,00000000h
						INVOKE	SendMessage,edi,LVM_SETTEXTBKCOLOR,0,00000000h

						INVOKE	SendMessage,edi,LVM_SETEXTENDEDLISTVIEWSTYLE,0,LVS_EX_FULLROWSELECT or LVS_EX_GRIDLINES or LVS_SORTASCENDING

;	========================================
;	=== Mettre les titres de la LISTVIEW ===
;	========================================

						mov		DWord Ptr [LvCol.imask],LVCF_TEXT or LVCF_WIDTH
						mov		DWord Ptr [LvCol.fmt],LVCFMT_LEFT
						mov		DWord Ptr [LvCol.lx],90
						mov		DWord Ptr [LvCol.pszText],OFFSET szIndex

						INVOKE	SendMessage,edi,LVM_INSERTCOLUMN,0,esi

						mov		DWord Ptr [LvCol.imask],LVCF_FMT or LVCF_TEXT or LVCF_WIDTH
						mov		DWord Ptr [LvCol.fmt],LVCFMT_LEFT
						mov		DWord Ptr [LvCol.pszText],OFFSET szRouge

						INVOKE	SendMessage,edi,LVM_INSERTCOLUMN,1,esi

						mov		DWord Ptr [LvCol.pszText],OFFSET szVert

						INVOKE	SendMessage,edi,LVM_INSERTCOLUMN,2,esi

						mov		DWord Ptr [LvCol.pszText],OFFSET szBleu

						INVOKE	SendMessage,edi,LVM_INSERTCOLUMN,3,esi

						mov		DWord Ptr [LvCol.pszText],OFFSET szCount

						INVOKE	SendMessage,edi,LVM_INSERTCOLUMN,4,esi

						ret
Colors_SetColums		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

Colors_InsertItem		PROC	USES EDI ESI,hWnd:HWND,lpColors:PTR COLORS_SEARCH,lpszRed:LPSTR,lpszGreen:LPSTR,lpszBlue:LPSTR,lpszCount:LPSTR,lpszIndex:LPSTR

						mov		DWord Ptr [Lvi.imask],LVIF_DI_SETITEM or LVIF_PARAM or LVIF_TEXT

;	===================================
;	=== Insrer le texte de l'index ===
;	===================================

						mov		eax,DWord Ptr [lpszIndex]
						mov		DWord Ptr [Lvi.pszText],eax

						mov		eax,DWord Ptr [lpColors]
						mov		DWord Ptr [Lvi.lParam],eax

						push	OFFSET Lvi
						push	0
						push	LVM_INSERTITEM
						push	DWord Ptr [hWnd]
						call	SendMessage 

;	=============
;	=== Rouge ===
;	=============

						inc		DWord Ptr [Lvi.iSubItem]

						mov		eax,DWord Ptr [lpszRed]
						mov		DWord Ptr [Lvi.pszText],eax

						push	OFFSET Lvi
						push	0
						push	LVM_SETITEM
						push	DWord Ptr [hWnd]
						call	SendMessage 

;	============
;	=== Vert ===
;	============

						inc		DWord Ptr [Lvi.iSubItem]

						mov		eax,DWord Ptr [lpszGreen]
						mov		DWord Ptr [Lvi.pszText],eax

						push	OFFSET Lvi
						push	1
						push	LVM_SETITEM
						push	DWord Ptr [hWnd]
						call	SendMessage 

;	============
;	=== Bleu ===
;	============

						inc		DWord Ptr [Lvi.iSubItem]

						mov		eax,DWord Ptr [lpszBlue]
						mov		DWord Ptr [Lvi.pszText],eax

						push	OFFSET Lvi
						push	2
						push	LVM_SETITEM
						push	DWord Ptr [hWnd]
						call	SendMessage 

;	================
;	=== Compteur ===
;	================

						inc		DWord Ptr [Lvi.iSubItem]

						mov		eax,DWord Ptr [lpszCount]
						mov		DWord Ptr [Lvi.pszText],eax

						push	OFFSET Lvi
						push	3
						push	LVM_SETITEM
						push	DWord Ptr [hWnd]
						call	SendMessage 

;	===============================
;	=== Prparer l'item suivant ===
;	===============================

						inc		DWord Ptr [Lvi.iItem]
						mov		DWord Ptr [Lvi.iSubItem],0

;	===========================
;	=== Fin de la procdure ===
;	===========================

						ret
Colors_InsertItem		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

Colors_SetItems			PROC	USES EDI ESI,hWnd:HWND,dwHexa:DWord
						LOCAL	dwCount:DWord
						LOCAL	szLibRed[32]:Byte
						LOCAL	szLibGreen[32]:Byte
						LOCAL	szLibBlue[32]:Byte
						LOCAL	szLibCount[32]:Byte
						LOCAL	szLibIndex[32]:Byte
						LOCAL	lpszCount:LPSTR
						LOCAL	lpszIndex:LPSTR
						LOCAL	lpszRed:LPSTR
						LOCAL	lpszGreen:LPSTR
						LOCAL	lpszBlue:LPSTR

						xor		eax,eax

						mov		DWord Ptr [Lvi.iItem],eax
						mov		DWord Ptr [Lvi.iSubItem],eax
						mov		DWord Ptr [Lvi.state],eax
						mov		DWord Ptr [Lvi.stateMask],eax
						mov		DWord Ptr [Lvi.iImage],eax
						mov		DWord Ptr [Lvi.iIndent],eax

						mov		DWord Ptr [dwCount],eax
						mov		DWord Ptr [dwHexa],eax

						mov		esi,DWord Ptr [lpdwColors]
						mov		edi,01000000h

						lea		eax,szLibIndex
						mov		DWord Ptr [lpszIndex],eax

						lea		eax,szLibCount
						mov		DWord Ptr [lpszCount],eax

						lea		eax,szLibBlue
						mov		DWord Ptr [lpszBlue],eax

						lea		eax,szLibGreen
						mov		DWord Ptr [lpszGreen],eax

						lea		eax,szLibRed
						mov		DWord Ptr [lpszRed],eax

Colors_SetItems_Loop :

						cmp		DWord Ptr (COLORS_SEARCH Ptr [esi]).dwCount,0
						je		Colors_SetItems_LoopNext

						INVOKE	wsprintf,lpszCount,ADDR szFmtIndexDecimal,(COLORS_SEARCH Ptr [esi]).dwCount
						INVOKE	wsprintf,lpszIndex,ADDR szFmtIndexDecimal,(COLORS_SEARCH Ptr [esi]).dwIndex
						INVOKE	wsprintf,lpszRed,ADDR szFmtIndexDecimal,(COLORS_SEARCH Ptr [esi]).dwRed
						INVOKE	wsprintf,lpszGreen,ADDR szFmtIndexDecimal,(COLORS_SEARCH Ptr [esi]).dwGreen
						INVOKE	wsprintf,lpszBlue,ADDR szFmtIndexDecimal,(COLORS_SEARCH Ptr [esi]).dwBlue

						push	DWord Ptr [lpszIndex]
						push	DWord Ptr [lpszCount]
						push	DWord Ptr [lpszBlue]
						push	DWord Ptr [lpszGreen]
						push	DWord Ptr [lpszRed]
						push	esi								; lpdwColors
						push	DWord Ptr [hWnd]				; Handle de la LISTVIEW
						call	Colors_InsertItem

Colors_SetItems_LoopNext :

						add		esi,(SIZEOF COLORS_SEARCH)

						dec		edi
						jnz		Colors_SetItems_Loop

						ret
Colors_SetItems			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

Colors_Init				PROC	USES EBX EDI ESI,hWnd:HWND
						LOCAL	dwHexa:DWord

						INVOKE	IsDlgButtonChecked,hWnd,IDC_CHECK_01

						cmp		eax,BST_CHECKED
						je		Colors_Init_Checked

						xor		eax,eax
						jmp		Colors_Init_1

Colors_Init_Checked :

						xor		eax,eax
						inc		eax

Colors_Init_1 :

						mov		DWord Ptr [dwHexa],eax

;	========================================
;	=== Obtenir le handle de la LISTVIEW ===
;	========================================

						push	IDC_LIST_01
						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		GetDlgItem

						mov		edi,eax					; Handle de la LISTVIEW

;	========================================
;	=== Mettre les titres de la LISTVIEW ===
;	========================================

						push	eax
						call	Colors_SetColums

;	============================================
;	=== Mettre les couleurs dans la LISTVIEW ===
;	============================================

						push	DWord Ptr [dwHexa]
						push	edi						; Handle de la LISTVIEW
						call	Colors_SetItems

						mov		Lvi.imask,LVIF_STATE
						mov		Lvi.stateMask,LVIS_FOCUSED or LVIS_SELECTED
						mov		Lvi.state,LVIS_FOCUSED or LVIS_SELECTED
						mov		Lvi.iItem,0

						push	OFFSET Lvi
						push	0
						push	LVM_SETITEMSTATE
						push	edi
						call	SendMessage 

						ret
Colors_Init				ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################
