						.Code

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

Colors_Work				PROC	USES EBX EDI ESI,hWnd:HWND
						LOCAL	dwColor:DWord
						LOCAL	dwCount:DWord
						LOCAL	hDC:HDC
						LOCAL	lpColor:PTR COLORS_SEARCH
						LOCAL	szTmp[256]:Byte

;	==========================================
;	=== Obtention du handle de la LISTVIEW ===
;	==========================================

						push	IDC_LIST_01
						push	DWord Ptr [hWnd]
						call	GetDlgItem

						mov		edi,eax

;	=====================================
;	=== Rechercher l'item slectionn ===
;	=====================================

						invoke	SendMessage,edi,LVM_GETNEXTITEM,-1,LVNI_SELECTED or LVNI_ALL or LVNI_FOCUSED

						cmp		eax,-1
						je		Colors_Work_Error					; Aucun item n'est slectionn

;	====================================================
;	=== Rechercher les donnes de l'item slectionn ===
;	====================================================

						mov		Lvi.iItem,eax
						mov		Lvi.imask,LVIF_PARAM

						push	OFFSET Lvi
						push	0
						push	LVM_GETITEM
						push	edi
						call	SendMessage 

						mov		eax,DWord Ptr [Lvi.lParam]			; Adresse de la structure COLORS_SEARCH
						mov		DWord Ptr [lpColor],eax

						push	DWord Ptr (COLORS_SEARCH Ptr [eax]).dwColor
						pop		DWord Ptr [dwColor]

						push	DWord Ptr (COLORS_SEARCH Ptr [eax]).dwCount
						pop		DWord Ptr [dwCount]					; Nombre d'apparition

						mov		edx,DWord Ptr [lpImageBits]
						mov		ebx,DWord Ptr [lpWork]
						mov		edi,DWord Ptr [Image.bmHeight]
						mov		ecx,DWord Ptr [dwColor]

Colors_Work_Loop :

						mov		esi,DWord Ptr [Image.bmWidth]

Colors_Work_Loop_1 :

						mov		eax,DWord Ptr [edx]
						mov		DWord Ptr [ebx],0

						cmp		eax,ecx
						jne		Colors_Work_Loop_2

						mov		DWord Ptr [ebx],0ffffffh

Colors_Work_Loop_2 :

						add		ebx,SIZEOF DWord
						add		edx,SIZEOF DWord

						dec		esi
						jnz		Colors_Work_Loop_1

						dec		edi
						jnz		Colors_Work_Loop

						lea		eax,szTmp

						push	DWord Ptr [dwCount]
						push	DWord Ptr [dwColor]
						push	OFFSET szFmtTrancheColor
						push	eax
						call	wsprintf

						add		esp,16

						lea		eax,szTmp
						push	eax
						push	DWord Ptr [hWnd]
						push	OFFSET Colors_Work_Exit
						jmp		Colors_ShowImage 

Colors_Work_Error :

;	====================================
;	=== Aucun item n'est slectionn ===
;	====================================

						push	MB_OK or MB_APPLMODAL or MB_ICONEXCLAMATION
						push	OFFSET szError
						push	OFFSET szFmtError_004
						push	DWord Ptr [hWnd]
						call	MessageBox

						xor		eax,eax

Colors_Work_Exit :

						ret
Colors_Work				ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################
